from waonline.core.tabelle import Base, UniqueConstraint
from sqlalchemy import Table, Column, Integer, String, MetaData, Text, DateTime

class WebSession(Base):
    __tablename__ = 'web_session'
    key = Column('key', String(200), primary_key=True)
    data = Column('data', Text)
    expire_date = Column('expire_date', DateTime)
    cod_studio = Column('cod_studio', String(12))

session_table = WebSession.__table__
