# coding: utf-8
import os
import subprocess

from waonline import conf
#HOME = os.path.join(os.path.expanduser('~'), 'src/python/waonline')

def restart_server(stop=True, start=True):

    ## Nota: CWD è fondamentare per i riavvio del demone che se no non trova
    ## il file di conf e silenziosamente non parte
    if stop:
        subprocess.call('%s/scripts/wademon stop' % conf.WALL_DIR, shell=True,
                cwd=conf.WALL_DIR)
    if start:
        p=subprocess.Popen('%s/scripts/wademon start test' % conf.WALL_DIR,
                           shell=True, cwd=conf.WALL_DIR)

        p.communicate()

def truncate_wa(reload=[]):
    subprocess.Popen(['psql', 'WA_TEST', '-U', 'postgres', '-c',
              'TRUNCATE new_utenti, web_session, admin_log CASCADE'], ).communicate()
    for filename in reload:
        subprocess.Popen(('psql -Upostgres WA_TEST -f data/%s' % filename).split(),
                 cwd=os.path.join(conf.WALL_DIR, 'tests')).communicate()

def truncate_wa_900(reload=[]):
    subprocess.Popen(['psql', 'WA_900_TEST', '-U' 'postgres', '-c',
              'TRUNCATE ditte, utenti CASCADE'], shell=True).communicate()
    for filename in reload:
        subprocess.Popen(('psql -Upostgres WA_900_TEST -f data/%s' % filename).split(),
                 cwd=os.path.join(conf.WALL_DIR, 'tests')).communicate()

def get_db_manager():
    "Imposta tornado options con --nose"
    from waonline import wademon, conf
    from tornado.options import options

    options.nose = 1
    db_manager = wademon.DatabaseManager(db_url=conf.DEFAULT_DB_STR,
            db_base=conf.DEFAULT_DB_NAME)

    return db_manager

def get_session_manager():
    "Imposta tornado options con --nose"
    from waonline import wademon, conf
    from tornado.options import options

    options.nose = 1
    session_manager = wademon.sessions.SessionManager()
    return session_manager

