/* Definizione globali */
var listOrario = null;
var campiLista={
    c:{fields:[
            {name:'codice',title:"Codice"},
            //{name:'id',title:"ID"},
            {name:'nominativo',title:"Nominativo"},
            {name:'data_ass',title:"Data Assunzione"},
            {name:'data_cess',title:"Data Cessazione"},
            {name:'centro_costo',title:"Centro Costo"},
            {name:'livello',title:"Tipo Coll"},
            {name:'inail',title:"Inail"}
        ],
        titolo:"Collaboratori"
    },
    d:{fields:[
            {name:'codice',title:"Codice"},
            {name:'matricola',title:"ID"},
            {name:'nominativo',title:"Nominativo"},
            {name:'data_ass',title:"Data Assunzione"},
            {name:'data_cess',title:"Data Cessazione"},
            {name:'centro_costo',title:"Centro Costo"},
            {name:'qualifica',title:"Qualifica"},
            {name:'livello',title:"Livello"},
            {name:'inail',title:"Inail"}
        ],
        titolo:'Dipendenti'
    },
    s:{fields:[
            {name:'id', title:'Progressivo'},
            {name:'tipo',title:"Tipo"},
            {name:'nominativo',title:"Nominativo"},
            {name:'data_ingresso',title:"Data Ingresso", type:'date', formatCellValue:"wao.intToDataStr(value);"},
            {name:'data_uscita',title:"Data Uscita", type:'date', formatCellValue:"wao.intToDataStr(value);"},
            {name:'qualifica',title:"Qualifica"},
            {name:'livello',title:"Livello"}
        ],
        titolo:'Somministati/Distaccati'
    }
};
var giorni = ['Do','Lu','Ma','Me','Gi','Ve','Sa'];
var _infoTmr = 0;
var _lCausali = null;
var _lCausaliEventi = null;
var _lVoci = null;
var _lCentriCosto = null;
var _lastFiltro = {periodo:null,cod_ditta:'0000000'};
var LRIDLE = 0;
var LRLOAD = 1;
var LRSUCCESS = 2;
var LRERROR = 3;

var _lastResponse = {
    done:function(){
        return this.stato;
    },
    init:function(){
        this.hasErrors=false;
        this.hasMessaggi= false;
        this.hasStato= false;
        this.hasConferma= false;
        this.response=null;
        this.callback=function(data){/*funzione nulla*/};
        this.confermaCallback=null;
        this.stato = LRIDLE;
    }
};
var _lastGriglia = null;
var ncartella ={getValue: function(){return 'ricevi';}};
var _cubeArgs= {};
var idDipeOld = 0;
var _original_onerror = window.onerror || function(msg, url, linenumber){
    isc.warn('Errore: '+msg+'<br/>URL: '+url+'<br/>Linea: '+linenumber);
    wao.debug_log.push('Errore: '+msg+'\nURL: '+url+'\nLinea: '+linenumber);
    isc.clearPrompt();
    return true; 
};

isc.DateItem.displayFormat="toEuropeanShortDate";
Date.displayFormat="toEuropeanShortDate";
isc.DateItem.useTextField = true;

/* Prototipi */
String.prototype.title = function(){
   return this.replace("_"," ").replace( /(^|\s)([a-z])/g , function(m,p1,p2){ return p1+p2.toUpperCase(); } );
};
String.prototype.trim = function(){
    return this.replace(/^\s+|\s+$/g,"");
};
String.prototype.eterep= function(n){
    n= n || 1;
    return Array(n+1).join(this);
};

/* Definizione wao */
var wao={
    /* proprietà */
    isPrism: "platform" in window,
    activeEditRecord: null,
    _refrCallbaks:{},
    _timeCallbacks:{},
    _saveFuncts:{},
    _tmp:{},
    _lastAzione: '',
    _lastNode: null,
    cellaAttuale: null,
    prefLoaded: false,
    debug_log:[],
    CANCEL  :0,
    YES     :1,
    NO      :2,
    CLOSE   :3,
    DONE    :4,
    first_time: 0,
    
    validators:{ 
        periodo:{
            type: "custom",
            condition: function(item, validator, value){
                var anno = 0;
                var mese = 0;
                var re = new RegExp(/(\d{2})\D+(\d{4})|(\d{4})\D+(\d{2})/);
                var m = re.exec(value);
                if (m){
                    anno = parseInt(m[2] || m[3], 10);
                    mese = parseInt(m[1] || m[4], 10);
                }else{
                    re.compile(/(\d{4})(\d{2})/);
                    m = re.exec(value);
                    if (m){
                        anno = parseInt(m[1], 10);
                        mese = parseInt(m[2], 10);
                        if ((mese < 0 | mese > 12) | (anno < 1900 | anno > 2050)){
                            re.compile (/(\d{2})(\d{4})/);
                            m = re.exec(value);
                            if (m){
                                anno = parseInt(m[2], 10);
                                mese = parseInt(m[1], 10);
                            }
                        }
                    }else{
                        re.compile(/(\d{1,2})/);
                        m = re.exec(value);
                        if (m){
                            mese = parseInt(m[1], 10);
                            anno = new Date().getFullYear();
                        }
                    }
                }
                if (mese < 1 | mese > 12){
                    validator.errorMessage = "mese non valido:" + mese;
                    return false;
                } 
                if (anno < 1900 | anno > 2050){
                    validator.errorMessage = "anno non valido:" + anno;
                    return false;
                }
                item.setValue(sprintf('%02d/%04d', mese, anno));
                return true;
            }
        }
    },
    formati:{ 
        "20%":function (valore){
            if (valore){
                return sprintf("%02.2d%%",valore);
            }else{
                return '';
            }
        }
    }, 
    installaPrism : function(nfile){
        if (this.isPrism){
            isc.say("<b>WebAzienda</b> è già in esecuzione da <b>Prism</b>.");
        }else{
            var url = "/html/WAOnline_1.4.exe";
            this.ask("L'installazione di questo modulo, oltre a consentire l'esecuzione di <b>WebAzienda</b> direttamente dal desktop, ne rende più performante l'utilizzo rispetto al normale browser.<br/> Si vuole scaricare il file?",{type:"sn",action:"window.open('"+url+"');"});
        }
    },
    download: function(url){
        isc.RPCManager.sendRequest(isc.RPCRequest.create({
            downloadResult: true,
            httpMethod: "POST",
            actionURL: url
        }));
    },
    up:{// userPreferences
        orientamento:'orizzontale',
        seleziona_tutti: true,
        ordinamento: 9,
        tipo_ordinamento:true
    },
    cookie:{
        set : function(args){
            var da = { name: null, value: null, expires: null, path: '/',
                domain: null, secure: false };
            da = wao.getArgs(args, da);
            document.cookie = da.name + "=" + escape(da.value) + 
                ((da.expires === null) ? "" : ("; expires=" + da.expires.toGMTString())) +
                ((da.path === null) ? "" : ("; path=" + da.path)) + 
                ((da.domain === null) ? "" : ("; domain=" + da.domain)) + 
                ((da.secure === true) ? "; secure" : "");
        },
        get : function(name){
            var arg = name + "=";
            var alen = arg.length;
            var clen = document.cookie.length;
            var i = 0;
            var j = 0;
            while(i < clen){
                j = i + alen;
                if(document.cookie.substring(i, j) == arg){
                    return this.getCookieVal(j);
                }
                i = document.cookie.indexOf(" ", i) + 1;
                if(i === 0){
                    break;
                }
            }
            return null;
        },
        clear : function(name){
            if(this.get(name)){
                document.cookie = name + "=" + "; expires=Thu, 01-Jan-70 00:00:01 GMT";
            }
        },
        getCookieVal : function(offset){
            var endstr = document.cookie.indexOf(";", offset);
            if(endstr == -1){
                endstr = document.cookie.length;
            }
            return unescape(document.cookie.substring(offset, endstr));
        }
    },
    sortByUp: function(){
        this.__sortMulti();
    },
    __sortMulti: function(){
        function _gms(args){
            if (!args) {
                return [];
            }
            var lista = [];
            for (var i = 0 ; i < args.length; i++){
                lista.push({property:args[i],direction:"ascending"});
            }
            return lista;
        }
        if (this.up.imp.tipo_ordinamento){
            switch(this.up.imp.ordinamento){
                case 1: case 6:
                    listDipendenti.groupBy('inail');
                    break;
                case 2: case 7:
                    listDipendenti.groupBy('qualifica');
                    break;
                case 3: case 8:
                    listDipendenti.groupBy('centro_costo');
                    break;
                default:
                    listDipendenti.ungroup();
                    break;
            }
        } else{
            listDipendenti.ungroup();
        }
        var lista = _gms([
                ['inail','codice'],
                ['qualifica','codice'],
                ['centro_costo','codice'],
                ['matricola'],
                ['nominativo'],
                ['inail','nominativo'],
                ['qualifica','nominativo'],
                ['centro_costo','nominativo'],
                ['codice']
        ][this.up.imp.ordinamento-1]);
        listDipendenti.setSortState({sortSpecifiers:lista});
    },
    formatCellNumerico: function(value){
        if (!this.isDefNotNull(value)) {return value;}
        value = String(value);
        if(isA.NumChar(value)){
            if (parseFloat(value, 10)){
                return sprintf("%2.2d",value.replace(',','.')).replace('.',',');
            }else{
                return '';
            }
        }else{
            return value;
        }
    },
    formatEditorNumerico: function(value){
        if (!this.isDefNotNull(value)) {return value;}
        value = String(value);
        if(isA.NumChar(value)){
            return sprintf("%2.2d",value.replace(',','.')).replace('.',',');
        }else{
            return value;
        }
    },
    formatCellaPercent: function(value){
       if (!this.isDefNotNull(value)) {return value;}
       value = String(value);
       return sprintf("%2.2d%%",value.replace("%","").replace(',','.')).replace('.',',');
    },
    formatEditorPercent: function(value){
       if (!this.isDefNotNull(value)) {return value;}
       value = String(value);
       return sprintf("%2.2d",value.replace("%","").replace(',','.')).replace('.',',');
    },
    isNumber: function(n){
      try{n=n.replace(",",".");}catch(err){}
      return !isNaN(parseFloat(n)) && isFinite(n);
    },    
    isDef: function(value){
        return (typeof(value)!='undefined');
    },
    isDefNotNull: function(value){
        if (!this.isDef(value)) {return false;}
        return value!==null;
    },
    isDefHasLength: function(value){
        if(this.isDefNotNull(value)){
            return((value).toString().length !==0 );
        }
        return false;
    },
    getArgs: function(args,defaultArgs){
        var prop;
        if (isA.Object(args)){
            for(prop in args){
                if (args.hasOwnProperty(prop)){
                    defaultArgs[prop] = args[prop];
                }
            }
        }else{
            for(prop in defaultArgs){
                if (defaultArgs.hasOwnProperty(prop)){
                    defaultArgs [prop] = args;
                }
            }
        }
        return defaultArgs;
    },
    getArgVal: function(value,defaultValue){
        return (this.isDef(value)?value:defaultValue);
    },
    __getTimer:function(callback, timeout, times, forceEnd){
        this.callback = callback;
        this.times = times || null;
        this.ntimes = this.times;
        this.timeout = timeout;
        this.timeout_id = 0;
        this.finish = false;
        this.forceEnd = forceEnd || false;
        this.execTimer = function(who){
            try{
                var res = null;
                if (who.ntimes !== 0){
                    res = wao.__fCallback(who.callback);
                    who.timeout_id = setTimeout(function(){who.execTimer(who);}, who.timeout);
                    if (who.ntimes !== null){
                        if (res !== false || who.forceEnd === true){who.ntimes--;}
                    }
                }else{
                    who.finish = true;
                    wao.removeTimeCallback();
                }
            }catch(erroret){
                wao.log(erroret);
            }
        };
        this.execTimer(this);
    },
    addTimeCallback: function(func_id, callback, timeout, times, forceEnd){
        func_id = func_id || isc.timeStamp();
        this.removeTimeCallback(func_id);
        this._timeCallbacks[func_id] = new this.__getTimer(callback, timeout, times, forceEnd);
    },
    removeTimeCallback: function(funcId){
        if (funcId){
            if (funcId in this._timeCallbacks){
                clearTimeout(this._timeCallbacks[funcId].timeout_id);
                delete this._timeCallbacks[funcId];
            }
        }else{ 
            for (var func_id in this._timeCallbacks){
                if (this._timeCallbacks.hasOwnProperty(func_id)){
                    if (this._timeCallbacks[func_id].finish){
                        clearTimeout(this._timeCallbacks[func_id].timeout_id);
                        delete this._timeCallbacks[func_id];
                    }
                }
            }
        }
    },
    addRefCallback: function(nome,callback){
        this._refrCallbaks[nome]=callback;
    },
    removeRefCallback:function(nome){
        delete this._refrCallbaks[nome];
    },
    refreshCallback: function(){
        var args = {
            includi:isc.getKeys(this._refrCallbaks),
            escludi:[]
        };
        if (this.isDefNotNull(arguments[0])){
            if (isA.Array(arguments[0])){
                args.escludi = this.getArgVal(arguments[0],args.escludi);
            }else{
                args = this.getArgs(arguments[0],args);
            }
        }
        for (var i = 0; i < args.includi.length ; i++){
            var callback = args.includi[i];
            if (this._refrCallbaks.hasOwnProperty(callback)){
                try{
                    if (!args.escludi.contains(callback)){
                        this.__fCallback(this._refrCallbaks[callback]);
                    }
                }catch(errore_1){}
            }
        }
    },
    __fCallback: function(){
        var args = Array.prototype.slice.call(arguments);
        var func = args.shift();
        if (!func) {
            return null;
        }
        var obj = this;
        if (isA.Object(func)){
            obj = func.obj || obj;
            args = func.args;
            func = func.func;
            if(!isA.Array(args)) {args=[args];}
        }else{
            if (isA.Object(args[1])){obj=args[1];}
            args =  args[0];
            if(!isA.Array(args)) {args=[args];}
        }
        if (isA.Function(func)){
            return func.apply(obj,args);
        }else if(isA.String(func)){
            var nargs = [];
            var r = new RegExp( /\w+\s*\((.+?)\)/g);
            var m = r.exec(func);
            while(m){
                n = m[1].split(",");
                for (var i; i < n.length; i++){ 
                    if (!isA.NumChar(n[i])){nargs.push(n[i]);} 
                }
                m = r.exec(func);
            }
            r = new RegExp(/\w+?\s*=\s*(\w+)\s*/g);
            m = r.exec(func);
            while(m){
                n = m[1].replace(/\s*/g,'');
                if (n.length){nargs.push();}
                m = r.exec(func);
            }
            return Class.evaluate(func,args[0]);
        }else{
            throw new TypeError("Funzione di callback non valida");
        }

    },
    askForValue: function(messaggio, callback, proprieta){
        proprieta = proprieta || isc.emptyObject;
        var askDia = isc.Dialog.Ask;
        var valField = {
            name: "value",
            showTitle: false,
            width: "*",
            validateOnChange: true
        };
        if (wao.isDefNotNull(proprieta.field)){
            valField = this.getArgs(proprieta.field, valField);
        }
        if (!askDia) {
            var askForm = isc.DynamicForm.create({
                numCols: 1,
                padding: 3,
                items: [
                    { name: "message", type: "blurb" },
                    valField
                ],
                saveOnEnter: true,
                submit: function() {
                    this.askDialog.okClick();
                }
            });
            askDia = isc.Dialog.Ask = isc.Dialog.create({
                items: [askForm],
                askForm: askForm,
                canDragReposition: true,
                isModal: true,
                bodyProperties: {
                    overflow: "visible"
                },
                overflow: "visible"
            });
            askForm.askDialog = askDia;
            askDia.$14o = function() {
                this.clear();
                if (this.askForm.validate()){
                    this.returnValue(this.askForm.getValue("value"));
                }
            };
        }
        // var centra = proprieta.left != null || proprieta.top != null;
        var centra = wao.isDefNotNull(proprieta.left) || wao.isDefNotNull(proprieta.top);
        if (wao.isDefNotNull(proprieta.buttons)) {
            proprieta.toolbarButtons = proprieta.buttons;
            delete proprieta.buttons;
        }
        proprieta = isc.addProperties({
            callback: callback,
            title: proprieta.title || isc.Dialog.ASK_FOR_VALUE_TITLE,
            autoCenter: !centra,
            left: (centra ? proprieta.left || "10%": null),
            top: (centra ? proprieta.top || "20%": null),
            width: proprieta.width || "80%",
            height: proprieta.height || 20,
            toolbarButtons: proprieta.toolbarButtons || [isc.Dialog.OK, isc.Dialog.CANCEL],
            okClick: proprieta.okClick || askDia.$14o
        },
        proprieta);
        isc.$14m(proprieta);
        askDia.setProperties(proprieta);
        askDia.askForm.setValues({
            message: messaggio || "Please enter a value:",
            value: proprieta.defaultValue || ""
        });
        askDia.show();
        askDia.askForm.focusInItem("value");

    },
    ask:function(messaggio,args){
        var _btns = {
            s:isc.Dialog.YES,
            n:isc.Dialog.NO,
            a:isc.Dialog.CANCEL,
            c:isc.Dialog.CLOSE
        };
        var nargs = {
            action:null,
            done:null,
            cancel:null,
            doDone: true,
            buttons: [isc.Dialog.YES, isc.Dialog.NO, isc.Dialog.CANCEL],
            type:"sna", // Si No Annulla
            callback: function(scelta,askDialog){
                switch(scelta){
                    case wao.YES:
                        if (this.action){wao.__fCallback(this.action);}
                        if (this.doDone){if (this.done){wao.__fCallback(this.done);}}
                        break;
                     case wao.NO:
                        if (this.done){wao.__fCallback(this.done);}
                        break;
                     default:
                        if (this.cancel){wao.__fCallback(this.cancel);}
                        break;
                }
               askDialog.clear();
               _lastResponse.hasConferma = false;
            }
        };
        if (isc.isA.Object(args)){
            nargs.action = args.action || nargs.action;
            nargs.done = args.done || nargs.done;
            nargs.type = args.type || nargs.type;
            if (wao.isDefNotNull(args.doDone)){
                nargs.doDone = args.doDone;
            }
            if (( nargs.yes && nargs.no && nargs.cancel)===null){
                throw new TypeError('Nessuna funzione di callback');
            }
            nargs.buttons =[];
            var bt = nargs.type.split('');
            for (var i = 0; i < bt.length; i++){
                nargs.buttons.push(_btns[bt[i].toLowerCase()]);
            }
        }else if (isA.Function(args) || isA.String(args)){
            nargs.action = args;
        }else{
            throw new TypeError('Funzione di callback non valida');
        }
        isc.ask(messaggio,nargs.callback,{
            title: "WebAzienda",
            buttons: nargs.buttons,
            obj: nargs,
            yesClick: function(){this.obj.callback(wao.YES,this);},
            noClick: function(){this.obj.callback(wao.NO,this);},
            cancelClick: function(){this.obj.callback(wao.CANCEL,this);}
        });
    },
    __stdSetData: function(){
        var source = arguments[0];
        var lista = arguments[1];
    },
    getIdDipe: function(){
        try {
            return listDipendenti.rscroll.record().id;
        }catch(errore_2){}
        return null;
    },
    getCodDitta: function(){
        if (typeof findCodice != "undefined"){
            return findCodice.getValue();
        }
        return null;
    },
    getIdDitta: function(){
         if (typeof findCodice != "undefined"){
             var record = findCodice.getSelectedRecord();
             if (record){
                 return record.cod_ditta;
             }
         }
         return null;
    },
    getPeriodo: function(){
        try{
            return listPeriodi.getValue();
        }catch(err_p){}
        return null;
    },
    isAperto: function(){
        try{
            return listPeriodi.getSelectedRecord().stato=="Aperto" & wao.up.imp.auto_presenze == 'A';
        }catch(errore_3){
            return false;
        }
    },
    isModAna: function(){
        try{
            return wao.up.imp.auto_anagrafiche == "A";
        }catch(errore_4){
            return false;
        }
    },
    hasDomicilio: function(id_dipendente){
        try{
            id_dipendente = id_dipendente || listDipendenti.rscroll.record().id;
            return listDipendenti.rscroll.getRecord(id_dipendente).qualifica.substr(0,1)=='6';
        }catch(errore){
            return false;
        }
    },
    needPeriodi: function(){
        try{
            return listPeriodi.isDrawn() !== true;
        }catch(adfw){
            return true;
        }
        if (listPeriodi.isVisible()){
            return false;
        }else{
            try {
                return !lstPeriodi.isVisible();
            }catch(erraw){
                return true;
            }
        }
        return true;
    },
    getUserPref: function(){
        this.prefLoaded = false;
        newSendData({
            url: "app/utenti/get_user",
            //blocking: true,
            params:{
                id_ditta: this.getIdDitta(),
                id_genitore: this.id
            },
            callback:function(data){
                if(data){
                    listPeriodi.optionDataSource='periodiSource';
                    wao.up = data;
                    if (wao.up.ditta) {
                        wao.up.imp = wao.up.ditta.impostazioni;
                        wao.up.pref = wao.up.ditta.preferenze;
                    } else {
                        wao.up.imp = wao.up.impostazioni;
                        wao.up.pref = wao.up.preferenze;
                    }
                    var cmddiv = null;
                    if (wao.up.is_mutante){
                        if (!document.getElementById('studioStar')){
                            cmddiv = document.getElementById('cmdDiv');
                            cmddiv.innerHTML = '<a id="studioStar" href="javascript:wao.__backToStudio()"><img src="/img/icons/services.png"/>Ritorna</a>'+cmddiv.innerHTML;
                        }
                    }else{
                        try{studioStar.destroy();}
                        catch(errore_6){}
                    }
                    if (wao.inLoad){
                        if (wao.up.livello > 40){
                            creaGestioneUtenti();
                        }
                        if (wao.up.livello > 40){
                            document.getElementById('wahelp').href="/html/help/indexstudio.html";
                        }else{
                            document.getElementById('wahelp').href="/html/help/indexditta.html";
                        }
                        infoTop.setContenuto();
                    }
                    wao.prefLoaded = true;
                }
            }
        });
    },
    __backToStudio:function(){
        wao.ask("<p><b>"+wao.up.studio.codice + " - " + wao.up.studio.descrizione+"</b></p>"+
            "<p>Tornare in modalità studio ?</p>",
            {
                type:"sn",
                action:function(){
                     newSendData({
                        url: 'app/utenti/ritorna',
                        callback: function(data){
                            if (!_lastResponse.hasErrors){
                                document.location="/";
                            }
                        }
                    });
                }
            }
       );
    },
    isStudio: function(){
        return (this.up.livello == 40);
    },
    isMutante: function(){
        if (this.isDefNotNull(this.up.is_mutante)){
            return this.up.is_mutante;
        }else{
            return false;
        }
    },
    intToDataStr: function(data){
        if (data){
            data = data.toString();
            if (data.length == 8){
                data = new Date(parseInt(data.substr(0,4),10), parseInt(data.substr(4,2), 10) - 1, parseInt(data.substr(6,2),10));
                return this.toData(data);
            }else if (data.length == 6){
                return data.substr(4,2) + "/" + data.substr(0,4);
            }
        }else{
            return '';
        }
    },
    toData: function(data){
        if (is.Date(data)){
            return sprintf("%02d/%02d/%04d",data.getDate(),data.getMonth()+1,data.getFullYear());
        }
        return data;
    },
    toOra: function(data){
        if (is.Date(data)){
            return sprintf("%02d:%02d",data.getHours(),data.getMinutes());
        }
        return data;
    },
    haveEnough: function (record,lista){
       var tot = true;
       var nlista;
       if (!isA.Array(lista)){
           nlista = lista.fields.findAll('required',true).getProperty('name');
       }else{
           nlista=lista;
       }
       for (var i = 0; i < nlista.length;i++) {
            if (record.hasOwnProperty(nlista[i])){
                tot &= this.isDefHasLength(record[nlista[i]]);
            }else{
                tot &= false;
            }
       }
       return tot;
    },
    formatThis: function(valore, formato){
        if (this.formati.hasOwnProperty(formato)){
            try{
                var fformato = this.formati[formato];
                if (isA.Function(formato)){
                    return fformato(valore);
                }else{
                    return sprintf(fformato, valore);
                }
            }catch(errore_7){
                return valore;
            }
        }else{
            return valore;
        }
    },
    aggiornaPeriodo: function(){
       var cod_ditta = this.getCodDitta();
       if (cod_ditta){
           periodiSource.defaultParams = {cod_ditta:cod_ditta};
           if (! listPeriodi.pickList){
               listPeriodi.fetchData();
           }
           listPeriodi.pickList.fetchData();
           //listPeriodi.fetchData({cod_ditta:cod_ditta});
           listPeriodi.setTop();
           try{
               listPeriodi.pickList.markForRedraw();
               listPeriodi.pickList.redraw();
               listPeriodi.redraw();
           }catch(err){}
       }
    },
    getValues: function(item){
        var values = null;
        if (this.isDef(item.getValues)){
            values = item.getValues();
        }else{
            values = item;
        }
        var list = arguments[1] || null;
        if (list){
            var nlist = {};
            for (var i =  0; i < list.length;i++ ){
                if (values.hasOwnProperty(list[i])){
                    nlist[list[i]]=values[list[i]];
                }
            }
            return nlist;
        }else{
            return values;
        }
    },
    addSaveFunct: function(objID, funct){
        this._saveFuncts[objID] = funct;
    },
    removeSaveFunc: function(objID){
        delete this._saveFuncts[objID];
    },
    verificaSalvataggio: function(callback, argomenti){
        var doCallback = true;
        if (_lastGriglia){
            if (isc.getKeys(this._saveFuncts).contains(_lastGriglia.ID)){
                doCallback = this._saveFuncts[_lastGriglia.ID](callback, argomenti);
            }
        }
        if (doCallback){
            wao.__fCallback(callback,argomenti);
            return true;
        }else{
            return false;
        }
    },
    convertData: function(data){
        var m = data.match(/^(\d{1,2})\/(\d{1,2})\/(\d{4})$/);
        if (m){
            return new Date(parseInt(m[3],10),(parseInt(m[2],10)-1),parseInt(m[1],10));
        }else{
            return null;
        }
    },
    getAzione: function(node){
        if (node != wao._lastNode){
            if (wao._lastNode){
                wao._lastNode.enabled = true ;
            }
            wao._lastNode = node;
            if (node.azione){
                this.verificaSalvataggio(node.azione);
                wao._lastAzione = node.azione;
            }
        }
    },
    eseguiLogout: function(){
        document.location = '/logout';
        return true;
    },
    disabilitaScorrimento: function(stato){
        var fStato = listDipendenti.rscroll.isFirst();
        var lStato = listDipendenti.rscroll.isLast();
        if (wao.isDefNotNull(stato)){
            fStato = lStato = stato;
        }
        try{
            btnPrimo.setDisabled(fStato);
            btnPrec.setDisabled(fStato);
            btnPros.setDisabled(lStato);
            btnUltimo.setDisabled(lStato);
        }catch(errore){}
    },
    hideInfoMsg: function(){
        var o = document.getElementById('infoMsg');
        var m = document.getElementById('infoMsgText');
        m.innerHTML='';
        o.style.display="none";
        clearTimeout(_infoTmr);
    },
    showInfoMsg: function(messaggio){
        var to = 15000;
        var o = document.getElementById('infoMsg');
        var m = document.getElementById('infoMsgText');
        if(isc.isA.Object(messaggio)){
            m.innerHTML=messaggio.msg;
            if (this.isDefNotNull(messaggio.timeout)){
                to = messaggio.timeout;
            }
        }else{
            m.innerHTML=messaggio;
        }
        clearTimeout(_infoTmr);
        o.style.display="inline";
        if (to) {
            _infoTmr = setTimeout(wao.hideInfoMsg, to); 
        }else{
            to=0;
        }
    },
    mostraFiltri: function(stato){
        if (rightSideLayout.getSections('filtri')){
            var stati = {aziende:true, nominativo:true, periodo:true, cessati:true};
            stati = this.getArgs(stato, stati);
            if (isc.getValues(stati).or()){
                rightSideLayout.expandSection('filtri');
                rightSideLayout.getSection('filtri').show();
                if(stati.aziende===false){findCodice.hide();}else{findCodice.show();}
                if(stati.nominativo===false){findNominativo.hide();}else{findNominativo.show();}
                if(stati.periodo===false){listPeriodi.hide();}else{listPeriodi.show();}
                if(stati.cessati===false){escludi_cessati.hide();}else{escludi_cessati.show();}
            }else{
                rightSideLayout.collapseSection('filtri');
                rightSideLayout.getSection('filtri').hide();
            }
        }
    },
    getBottoni: function(qualibottoni){
        toolBottoni.removeButtons(toolBottoni.buttons);
        toolBottoni.removeMembers(toolBottoni.members);
        toolBottoni.addButtons(qualibottoni);
    },
    addSezione: function(titolo, oggetto){ 
        if (!pageLayout.hasMember(rightSideLayout)){
            pageLayout.addMember(rightSideLayout);
            try {
                infoFront.destroy();
            }catch(e){}
        }
        while(rightSideLayout.getSections().length > 1) {
            rightSideLayout.removeSection(1);
        }
        this.mostraFiltri(true);
        rightSideLayout.addSection({
            title: titolo,
            ID:'datiPane',
            canCollapse: false,
            expanded:true,
            autoShow:true,
            autoDraw:true,
            animateSections:false,
            items:[oggetto, toolBottoni]}
        );
    }, 
    getSecTitle: function(){
        return rightSideLayout.getSection('datiPane').title;
    },
    setSecTitle: function (titolo) {
        rightSideLayout.getSection('datiPane').setTitle(titolo);
        rightSideLayout.getSection('datiPane').markForRedraw();
    },
    refNum: function(){
        try{
            if (listDipendenti.isDrawn()){
                this.setSecTitle(this.getSecTitle().split(" ")[0] + " [" + listDipendenti.getTotalRows()+"]");
            }
        }catch(errls){}
    },
    nomeCantCC: function(){
        if (wao.up.imp.cant_cc=="cc"){
            return "Centri di costo";
        }else if (wao.up.imp.cant_cc=="ct"){
            return "Cantieri";
        }else{
            return '';
        }
    },
    periodoToDate: function(){
        var giorno = arguments[0]?arguments[0]:1;
        var periodo = this.getPeriodo().split("/");
        try{
            return new Date(parseInt(periodo[1],10),parseInt(periodo[0],10)-1,giorno);
        }catch(errore){
            return null;
        }
    },
    getMaxGiorni: function(){
        var d = this.periodoToDate() || new Date();
        return 32 - new Date(d.getFullYear(), d.getMonth(), 32).getDate();
    },
    init: function(){
    },
    log: function(what){
        try{console.log(what);}
        catch(err_l){}
        if (window.onerror){
            this.debug_log.push(what);
        }
    },
    load: function(){
        /* mettere qui le funzioni da far caricare al load */
        wao.inLoad = true;
        cmdDiv.draw();
        findCodice.optionDataSource = 'ditteSource';
        //findCodice.fetchData("wao.getUserPref();listPeriodi.optionDataSource='periodiSource';listPeriodi.fetchData();");
        findCodice.fetchData("wao.getUserPref();");
        this.addSaveFunct('lstPeriodi', _verificaSalvaStatus);
        this.addSaveFunct('listCampi', _verificaSalvaAnagrafiche);
        this.addSaveFunct('cuboPresenza', _verificaSalvaCalendario);
        this.addTimeCallback('infoRice',"infoRice.setContentsURL('/app/gestione/getRicInfo');", 900000, null);
        this.addTimeCallback('infoMovi',"infoMovi.setContentsURL('/app/gestione/getFilesInfo');", 900000, null);
        this.addTimeCallback('infoMoviChk',function() {
            if (wao.first_time){
                if (infoMovi.getInnerHTML()!='<div class="t1"><p class="p1">Ricevuti i seguenti files: </p></div>' && wao.up.livello==40){
                    isc.confirm("Ci sono degli aggiornamenti da parte dello studio, si vuole effettuarli ora?",
                    function(data){if(data){mostraRicevi();}});
                }
            }
            wao.first_time += 1;
        }, 3000, 2);
        this.addTimeCallback('infoTop',"infoTop.setContenuto();", 10, 1);
        this.addTimeCallback('prefLoaded',function(){
                if (wao.prefLoaded){
                    wao.inLoad = false;
                    return true;
                }else{
                    return false;
                }
            }, 10, 1);
        this.addTimeCallback('attivaDebug',function(){
                wao.debug_node = menuTree.getRecord(menuTree.data.indexOf({id:32}));
                if (!wao.debug_node){
                    return false;
                }
                if (!window.onerror){
                    wao.debug_node.nome = "Attiva debug";
                }else{
                    wao.debug_node.nome = "Disattiva debug";
                }
                menuTree.markForRedraw();
                return true;
            }, 100, 100, true);
        getDipeSource();
        if (this.isPrism){
            Page.setEvent('keyPress', function(){
                var key = isc.Event.getKey();
                if (key == 'f5'){
                    document.location = document.location;
                    return false;
                }
            });
        }
    }, 
    unload: function(){
    },
    beforeUnload: function(){
    },
    toggleDebug: function(){
        this._lastNode = null;
        if (!wao.debug_node){
            wao.debug_node = menuTree.getRecord(menuTree.data.indexOf({id:32}));
        }

        if (!window.onerror){
            window.onerror=_original_onerror;
            this.debug_node.nome = "Disabilita debug";
        }else{
            window.onerror = null;
            this.debug_node.nome = "Abilita debug";
        }
        menuTree.markForRedraw();
    }
};


/* Definizione WaoDateItem */
isc.defineClass("WaoDateItem", "DateItem").addProperties({
    displayFormat: "toEuropeanShortDate",
    dateFormatter: "toEuropeanShortDate",
    useTextField: true,
    inputFormat: "DMY",
    //inputFormat: "DD/MM/YYYY",
    autocomplete: false,
    stopIfFalse: true,
    change:function (form, item, value){
        var data;
        var nvalue = '';
        if (this.autocomplete == "periodo"){
            data = wao.periodoToDate();
        }else if( this.autocomplete == 'now'){
            data = new Date();
        }else{
            data = null;
        }
        if (typeof (value) == 'string'){
            var m;
            if (data){
                m = value.match(/^(\d{2})(\d{2})(\d{4})$|^(\d{2})(\d{2})$|^(\d{1,2})/);
                if (m){
                    if (m[1]){
                        value = sprintf("%02d/%02d/%04d",parseInt(m[1],10),parseInt(m[2],10),parseInt(m[3],10));
                    }else if (m[4]){
                        value = sprintf("%02d/%02d/%04d",parseInt(m[4],10),parseInt(m[5],10),data.getFullYear());
                    }else if (m[6]){
                        value = sprintf("%02d/%02d/%04d",parseInt(m[6],10),data.getMonth()+1,data.getFullYear());
                    }
                }
            } else {
                m = value.match(/^(\d{2})(\d{2})(\d{4})$/);
                if (m){
                    if (m[1]){
                        value = sprintf("%02d/%02d/%04d",parseInt(m[1],10),parseInt(m[2],10),parseInt(m[3],10));
                    }
                }
            }
            nvalue = wao.toData(value);
        }else{
            if (value){
                nvalue = wao.toData(value);
            }
        }
        //this.Super('changed',arguments);
        this.setValue(nvalue.toString());
        if (this.changed2){
            wao.__fCallback(this.changed2, arguments);
        }
        return true;
    }
});
/* Definizione WaoTextItem */
isc.defineClass("WaoTextItem", "TextItem").addProperties({
    init: function(){
        return this.Super("init", arguments);
    },
    startEditing: function(rowNum, colNum, suppressFocus){
        return this.Super(startEditing, arguments);
    },
    formatEditorValue: function(value, record, rowNum, colNum, grid){
        this.length = parseInt(record.caratteri,10);
        this.Super('formatEditorValue', arguments);
        return value;
    },
    validate: function(validateHiddenFields){
        _ttl("Validate");
    },
    validateData: function(){
        _ttl("ValidateData");
    },
    _postInit: function(){
    }
});

/* Definizione PresComboBoxItem */
isc.defineClass("PresComboBoxItem", "ComboBoxItem").addProperties({
    selectOnFocus:false,
    length:8,
    noSelect: false,
    elemento: null,
    focus: function (form, item){
        if (this.getValue() !== null){
            if (this.getValue().length > 2){
                this.setSelectionRange(3,8);
            }else{
                this.getElement().select();
            }
        }
    },
    pickValue: function(value){
        var oldVal = this.getValue().split(" ");
        if (oldVal.length == 2){
            arguments[0] += " " + oldVal[1];
        }
        this.focus();
        return this.Super('pickValue', arguments);
    }
});

/* Definizione PresTextItem */
isc.defineClass("PresTextItem", "TextItem").addProperties({
    selectOnFocus:false,
    length:8,
    focus: function (form, item){
        this.Super('focus',arguments);
        wao.cellaAttuale = this;
        if (this.getValue() !== null){
            if (this.getValue().length > 2){
                this.setSelectionRange(3,8);
            }else{
                this.getElement().select();
            }
        }
    },
    doubleClick: function(form, item){
        if (form.grid.presTextDoubleClick){
            var record = item.grid.getRecord(item.rowNum, item.colNum);
            form.grid.presTextDoubleClick(item, record, item.getValue());

        }
    }
});

/* Definizione DipendentiGrid */
isc.defineClass('DipendentiGrid','ListGrid').addProperties({
    visible:false,
    ID: "listDipendenti",
    dataSource: "dipeSource",
    alternateRecordStyles:true,
    emptyMessage: '',
    promptStyle: 'cursor',
    showPrompt: true,
    showAllRecords:true,
    //useAllDataSourceFields: true,
    wrapCells: true,
    fixedRecordHeights: false,
    canDragRecordsOut:false,
    canReorderRecords:true,
    canAcceptDroppedRecords:false,
    hoverWidth:200,
    hoverHeight:20,
    autoDraw:false,
    canGroupBy: true,
    groupStartOpen: 'all',
    loadingDataMessage : "Caricamento dati...",
    cancelEditingConfirmationMessage : "Eliminando questa modifica verranno perse tutte le modifiche non salvate per questo record, continuare?",
    confirmDiscardEditsMessage : "Questa azione scarterà tutte le modifiche non salvate per questa lista",
    discardEditsSaveButtonTitle : "Salva",
    freezeOnRightText : "Blocca a destra",
    freezeOnLeftText : "Blocca a sinistra",
    sortFieldAscendingText : "Ordinamento Ascendente",
    sortFieldDescendingText : "Ordinamento Discendente",
    fieldVisibilitySubmenuTitle : "Colonne",
    freezeFieldText : "Blocca ${viewer.getSummaryTitle(field)}",
    unfreezeFieldText : "Sblocca ${viewer.getSummaryTitle(field)}",
    groupByText : "Raggruppa per ${title}",
    ungroupText : "Togli raggruppamento",
    lastRow: 0,
    last_filtro: {},
    ritorna: false,
    conta_coso: 0,
    sortAndGroup: function(){
        if (this.selectionAppearance == 'checkbox' ){
            var ricarica = wao._lastAzione.indexOf('creaAnagrafichePresenze') !== -1;
            if (dipeSource.compareCriteria(this.last_filtro, findForm.getValuesAsCriteria())){
                wao.sortByUp();
                if (wao.up.imp.seleziona_tutti){
                    this.selectAllRecords();
                    if (wao.up.imp.tipo_ordinamento){
                        this.headerClick(0);
                    }
                }
                this.last_filtro = findForm.getValuesAsCriteria();
            }else{
                listDipendenti.rscroll.select();
            }

        }
    },
    initWidget:function(){
        this.Super('initWidget',arguments);
        this.rscroll = new LstScroller(this); 
    },
    selectionChanged: function (record, state){
        this.Super("selectionChanged",arguments);
        if (this.selectionAppearance == "checkbox") {this.rscroll.update();}
        var stato = !this.anySelected();
        for (var b = 0 ; b <  toolBottoni.members.length; b++){
            if (toolBottoni.members[b].nomod && !wao.isModAna()){
                toolBottoni.members[b].setDisabled(true);
            }else if (toolBottoni.members[b].nomodp && !wao.isAperto()){
                toolBottoni.members[b].setDisabled(true);
            }else if (toolBottoni.members[b].consel){
                toolBottoni.members[b].setDisabled(stato);
            }
        } 
    },
    headerClick: function (fieldNum){
        this.Super("headerClick",arguments);
        try{
            this.rscroll.update();
        }catch(errore_8){}
    }, 
    rowClick: function(record, recordNum, fieldNum, keyboardGenerated){
        this.Super('rowClick',arguments);
        try{this.rscroll.findPoint(record);}catch(errore_9){}
        this.refreshRow(this.lastRow);
        this.refreshRow(recordNum);
        this.lastRow = recordNum;
    },
    getCellCSSText: function (record, rowNum, colNum) {
        var csstxt = "border-right: 1px solid;";
        if (record && this.rscroll.record() && this.selectionAppearance=="checkbox" && listDipendenti.isSelected(record)){
            if (record.id == this.rscroll.record().id){
                csstxt += "background-color:#ffff40;";
            }
        }
        return csstxt;
    },
    getIdList: function(tutti){
        var idlist = [];
        var lista = null;
        if (tutti){
            lista = this.data.getRange(0, 1000);
        }else{
            lista = this.getSelection();
        }
        for (var i =0; i < lista.length;i++){
            if (wao.isDef(lista[i].id)){
                idlist.push(lista[i].id);
            }
        }
        return idlist;
    },
    getNameList: function(){
        var idlist = [];
        var lista = this.getSelection();
        for (var i =0; i < lista.length;i++){
            idlist.push(lista[i].codice + "-" + lista[i].nominativo);
        }
        return idlist;
    }
});

/* Definizione WaDataSource */
isc.defineClass('WaDataSource','RestDataSource').addProperties({
    hasErrors: false,
    hasMessaggi: false,
    hasStato: false,
    hasConferma: false,
    response: null,
    criteria: null,
    requestProperties: null,
    evalResult: true,
    evalVars: true,
    callback: function(data){/*funzione nulla*/},
    confermaCallback: null,
    defaultParams: {},
    type: null,
    task: null,
    dataFormat:'custom',
    jsonPrefix: null,
    jsonSuffix: null,
    method: 'post',
    httpMethod: 'post',
    init: function(){
        this.Super('init',arguments);
        this._backCall = this.callback;
        this.httpHeaders = {requester: "WaDataSource"};
        this.defaultParams._requester = "WaDataSource";
    },
    _reinit: function(){
        this.hasErrors = false;
        this.hasMessaggi = false;
        this.hasStato = false;
        this.hasConferma = false;
        this.response = null;
        this.callback = this._backCall;
    },
    fetchData: function(criteria, callback, requestProperties){
        if (this.type === null || this.task === null){
           throw new URIError ("Mancano il parametro type o il parametro task") ;
        }
        this.dataURL = _gURL({type: this.type, task: this.task});
        this._reinit();
        var ncriteria = criteria || this.criteria;
        this.callback = callback || this.callback;
        if (isA.Function(ncriteria)){
            ncriteria = ncriteria();
        }
        nrequestProperties = requestProperties || this.requestProperties;
        var args = [ncriteria, this._callback, nrequestProperties];
        return this.Super('fetchData',args);
    },
    transformResponse: function(dsResponse, dsRequest, data){
        try{
            return Class.evaluate(data);
        }catch(errore_10){
            try{
                return Class.evaluate("data=" + data);
            }catch(errore_11){
                try{
                    return {data: isc.XMLTools.toComponents(data)};
                }catch(errore_12){
                    return data;
                }
            }
        }
    },
    _callback: function(data) {
        this._response = data;
        var msg = [];
        this.response = null;
        if (wao.isDef(data.response)){
            this.response = data.response;
        }else if(wao.isDef(data.data)){
            if (wao.isDef(data.data.response)){
                this.response = data.data.response;
            }
        }
        if (wao.isDefNotNull(this.response)){
            msg = this.response.messaggi;
            this.hasErrors = (msg.findAll('tipo', 'errore') !== null);
            this.hasStato = (msg.findAll('tipo', 'stato') !== null);
            this.hasMessaggi = (msg.findAll('tipo', 'messaggio') !== null);
            this.hasConferma = (msg.findAll('tipo', 'conferma') !== null);
            this.parsedData = this.response.data || this.response.results || null;
        }else if (wao.isDef(data.data)){
            this.parsedData = data.data || null;
        }else if (wao.isDef(data.documentElement)){
            this.parsedData = data.documentElement;
        }else{
            this.parsedData = null;
        }
        if (this.parsedData){
            if (this.dataFormat == 'xml'){
                this.parsedData = isc.XMLTools.toJS(isc.XMLTools.selectNodes(this.parsedData, this.recordXPath));
            }else{
                try{
                    this.parsedData = Class.evaluate(this.parsedData);
                }catch(errore_13){
                    try{
                        this.parsedData = Class.evaluate("data=" + this.parsedData);
                    }catch(errore_14){}
                }
            }
        }else{
            this.parsedData = null;
        }
        if (this.hasStato) {
            var stato = msg.findAll('tipo', 'stato');
            var last_stato = stato.length - 1;
            showInfoMsg(stato[last_stato]);
        }
        if (this.hasMessaggi || this.hasErrors){
            var toshow = msg.map(function(item,index,array){
                if(item.tipo == 'errore' || item.tipo == 'messaggio') {return item;}
            });
            if (toshow[0]) {mostraFinestraMessaggi(toshow);}
        }
        if (this.hasConferma){
            if(this.confermaCallback){
                var conferma = msg.findAll('tipo', 'conferma')[0];
                if (isA.Array(conferma.tasti)){
                    var btn = { "YES":'s', "NO":'n', "CANCEL":'a',"CLOSE":'c' };
                    this.confermaCallback.type = '';
                    for (var i = 0; i < conferma.tasti.length; i++){
                        this.confermaCallback.type +=  btn[conferma.tasti[i]] || conferma.tasti[i];
                    }
                }else{
                    this.confermaCallback.type = conferma.tasti;
                }
                wao.ask(conferma.msg,this.confermaCallback);
            }
        }

        var dSend = this.parsedData;
        if (isA.String(this.callback)){dSend = {data: this.parsedData};}
        if (this.callback){wao.__fCallback({
            func: this.callback, 
            args: dSend,
            obj: this
            });
        }
    }
});

/* Definizione classe ListaEventi */
isc.defineClass("ListEventi", "ListGrid").addProperties({
    alternateRecordStyles:true,
    showHeaderContextMenu:false,
    canSort:false,
    canEdit:true,
    rowEndEditAction:"next",
    listEndEditAction:"next",
    send_url: "app/presenze/gestione_eventi",
    autoFetchData: false,
    validateByCell: true,
    stopOnErrors:true,
    sistemato:function(){
        this._hasChanges=false;
        this.saveAllEdits();
    },
    _hasChanges:false,
    hasChanges:function(){
        return (this.Super("hasChanges",arguments) && this._hasChanges);
    },
    verificaRiga: function (rowNum){
        if (typeof (rowNum) == 'undefined'){
            rowNum = this.getEditRow();
        }
        var r = this.getEditedRecord(rowNum);
        if(!this.validateRow(rowNum)){
            return false;
        }
        if(!wao.haveEnough(r,this)){
            return false;
        }
        if (r.codice_evento && (!r.data_inizio || !r.data_fine)){
            isc.warn("Devono essere presenti entrambe le date");
            return false;
        }
        try{
            r.ore_evento = r.ore_evento.replace(',','.');
        }catch(errore){}
        if (typeof(r.data_inizio) == "object"){
            try{
                r.data_inizio = r.data_inizio.toEuropeanShortDate();
            }catch(errore_1){}
        }
        if (typeof(r.data_fine) == "object"){
            try{
                r.data_fine = r.data_fine.toEuropeanShortDate();
            }catch(errore_2){}
        }
        this.validateRow(rowNum);
        if (this.hasErrors()){
            return false;
        }
        if (Date.compareDates(wao.convertData(r.data_inizio),wao.convertData(r.data_fine))==-1){
            isc.warn("La data di inizio deve essere inferiore alla data di fine evento");
            return false;
        }
        this.validateRow(rowNum);
        if (this.hasErrors()){
            return false;
        }
        return r;
    },
    saveEdits: function(editCompletionEvent, callback, rowNum){
        if (wao.isAperto()){
            var _ds = isc.DataSource.getDataSource(this.dataSource);
            rowNum = this.getEditRow();
            //var r = this.getEditedRecord(rowNum);
            var r = this.verificaRiga();
            if (r){
                r.id_dipte = idDipeOld;
                r.stato = "salva";
                r.codice_evento = r.codice_evento.toUpperCase();
                newSendData({
                    url: this.send_url,
                    params: r,
                    callback: function(data){
                        if (!_lastResponse.hasErrors){
                            _lastGriglia.verificaCallback(data);
                            dipeEventiSource.fetchData({id_dipte:idDipeOld},"listEventiDipe.setData(data);");
                        }
                    }
                });
                this._hasChanges=true;
            }
        }
    },
    deleteEdits: function(id_riga){
        if (wao.isAperto()){
            if (id_riga !== null && (id_riga != this.getTotalRows()-1)){
                var _ds = isc.DataSource.getDataSource(this.dataSource);
                var r = {};
                r.id_dipte = idDipeOld;
                r.stato = 'elimina';
                r.id_riga = id_riga;
                newSendData({
                    url: 'app/presenze/gestione_eventi',
                    params: r,
                    callback:function(data){
                        _lastGriglia.verificaCallback(data);
                        dipeEventiSource.fetchData({id_dipte:idDipeOld},"listEventiDipe.setData(data);");
                    }
                });
            }
        }
    },
    removeData: function(data){
        this.deleteEdits(data.id_evento);
    },
    validateCell: function(rowNum, fieldName) {
        var campo = this.getField(fieldName);
        var valore = this.getEditValue(rowNum, campo.name);
        if (campo.name == "codice"){
            if (valore) {
                verifica = verificaCausale(valore) || verificaCausaleEventi(valore);
                if (!verifica) {
                    alert("Causale non trovata");
                    return false;
                }
            }
        }
        return true;
    }
});

/* Definizione classe ListaVoci */
isc.defineClass("ListaVoci", "ListGrid").addProperties({
    alternateRecordStyles:true,
    showHeaderContextMenu:false,
    canSort:false,
    //modalEditing: true,
    canHover:false,
    editOnFocus: true,
    canEdit:true,
    rowEndEditAction:"next",
    listEndEditAction:"next",
    send_url: "app/presenze/gestione_voci",
    validateByCell: true,
    stopOnErrors:true,
    autoFetchData: false,
    sistemato:function(){
        this._hasChanges=false;
        this.saveAllEdits();
    },
    _hasChanges:false,
    hasChanges:function(){
        return (this.Super("hasChanges",arguments) && this._hasChanges);
    },
    saveEdits: function(editCompletionEvent, callback, rowNum){
        if (wao.isAperto()){
            var _ds = isc.DataSource.getDataSource(this.dataSource);
            if(typeof(rowNum)=='undefined'){
                rowNum = this.getEditRow();
            }
            var r = this.getEditedRecord(rowNum);
            if (!this.validateRow(rowNum)){
                return false;
            }
            if(!wao.haveEnough(r,this)){
                return false;
            }
            r.id_dipte = idDipeOld;
            r.stato = "salva";
            if (_ds){
                newSendData({
                    url: _gAppUrl(_ds.dataURL),
                    params: r,
                    callback: function(data){
                        var nData = [];
                        for (var i = 0; i < data.length;i++){
                            nData.push(data[i][_ds.recordXPath]);
                        }
                        listVociDipe.setData(nData);
                    }
                });
                this._hasChanges=true;
            }
            return true;
        }
    },
    deleteEdits: function(id_riga){
        if (wao.isAperto()){
            var _ds = isc.DataSource.getDataSource(this.dataSource);
            _ds.fetchData({ "stato":"elimina",
                    "id_dipte":idDipeOld,
                    "id_riga":id_riga
                },
                this.ID + ".setData(data)");
        }
    },
    validateCell: function(rowNum, fieldName) {
        var campo = this.getField(fieldName);
        var valore = this.getEditValue(rowNum, campo.name);
        if (campo.name=='codice'){
            if (valore) {
                verifica = verificaVoce(valore);
                if (!verifica) {
                    alert("Voce non trovata");
                    return false;
                }
            }
        }
        return true;
    }
});

/* Definizione classe ListaDomicilio */
isc.defineClass("ListaDomicilio", "ListGrid").addProperties({
    alternateRecordStyles:true,
    showHeaderContextMenu:false,
    canSort:false,
    canEdit:true,
    rowEndEditAction:"next",
    listEndEditAction:"next",
    send_url: "app/presenze/gestione_eventi",
    autoFetchData: false,
    validateByCell: true,
    stopOnErrors:true,
    emptyMessage:'',
    sistemato:function(){
        this._hasChanges=false;
        this.saveAllEdits();
    },
    _hasChanges:false,
    hasChanges:function(){
        return (this.Super("hasChanges",arguments) && this._hasChanges);
    },
    saveEdits: function(editCompletionEvent, callback, rowNum){
        if(wao.isAperto()){
            var _ds = isc.DataSource.getDataSource(this.dataSource);
            if (typeof(rowNum) =="undefined"){
                rowNum = this.getEditRow();
            }
            var r = this.getEditedRecord(rowNum);
            this.validateRow(rowNum);
            if(!wao.haveEnough(r,this)){
                return false;
            }
            r.id_dipte = idDipeOld;
            r.stato = "salva";
            r.data_consegna = wao.toData(r.data_consegna);
            r.data_riconsegna = wao.toData(r.data_riconsegna);
            r.ora_consegna = wao.toOra(r.ora_consegna);
            r.ora_riconsegna = wao.toOra(r.ora_riconsegna);
            if (_ds){
                newSendData({
                    url: _gAppUrl(_ds.dataURL),
                    params: r,
                    callback: function(data){
                        var nData = [];
                        for (var i = 0; i < data.length;i++){
                            nData.push(data[i][_ds.recordXPath]);
                        }
                        listDomicilioDipe.setData(nData);}
                });
                this._hasChanges=true;
            }
            return true;
        }
    },
    deleteEdits: function(id_riga){
        if (wao.isAperto()){
            var _ds = isc.DataSource.getDataSource(this.dataSource);
            _ds.fetchData({ "stato":"elimina",
                    "id_dipte":idDipeOld,
                    "id_riga":id_riga
                },
                this.ID + ".setData(data)");
        }
    }
});

/* Definizione classe LstScroller */
function LstScroller(lista){
    this.lista = lista;
    this.puntatore = 0;
    this.salta = false;
    this.update = function(){
        this.puntatore = 0;
        try{
            if (lista.selectionAppearance=="checkbox"){
                try{
                    this._lista=lista.getSelection();
                }catch(errore){
                    this._lista = [];
                }
            }else{
                var record = this.lista.getSelectedRecord();
                this.lista.selectAllRecords();
                this._lista=this.lista.getSelection();
                this.lista.deselectAllRecords();
                this.lista.selectRecord(record);
            }
        }catch(errore){
            this._lista = [];
        }
        this.count = this._lista.length;
        this.findPoint();
    };
    this.findPoint = function(record){
        if (!record) {record = this.lista.getSelectedRecord();}
        if(record){
            this.puntatore = this._lista.findIndex('id',record.id);
        }else{
            this.puntatore = 0;
        }
        if (this.puntatore == -1) {this.puntatore = 0;}
    };
    this.getRecord = function(id_dipte){
        for (var i = 0; i < this._lista.length;i++){
            if(this._lista[i].id == id_dipte) {
                return this._lista[i];
            }
        }
        return null;
    };
    this.setRecord = function(id_dipte){
        this.puntatore = this._lista.findIndex('id',id_dipte);
        if (this.puntatore == -1) {this.puntatore = 0;}
    };
    this.select = function(){
        if (this.lista.selectionAppearance!='checkbox') {return;}
        this.lista.selectRecord(this._lista);
    };
    this.next = function(){
        if (++this.puntatore >= this.count){
            this.puntatore = this.count-1;
        }
        return this._lista[this.puntatore];
    };
    this.prev = function(){
        if (--this.puntatore <= 0){
            this.puntatore = 0;
        }
        return this._lista[this.puntatore];
    };
    this.first = function(){
        this.puntatore = 0;
        return this._lista[0];
    };
    this.last = function(){
        this.puntatore = this.count-1;
        return this._lista[this.count-1];
    };
    this.record = function(){
        return this._lista[this.puntatore];
    };
    this.isFirst = function(){
        return (this.puntatore === 0);
    };
    this.isLast = function(){
        return (this.puntatore == (this.count-1));
    };
    this.update();
}

/* Definizione classe stdDialog */
isc.defineClass("stdDialog", "Window").addProperties({
    //ID: "wndDialogo",
    title: "WA Online",
    align: "left",
    width: 600,
    height: 400,
    autoSize: true,
    canDragReposition: true,
    showHeaderIcon: true,
    canDragResize: true,
    autoCenter: true,
    isModal: true,
    showModalMask: false,
    membersMargin: 6,
    autoDraw: true,
    buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
    items: [],
    headerIconDefaults:{
        height: 15,
        layoutAlign: "center",
        width: 15,
        src: "/img/karm16.png"
    },
    getButton: function(button){
        return this._toolBar.getButton(button);
    },
    confirmClick: function(){
        if(this.confirm()) {this.destroy();}
    },
    yesClick: function(){
        this.destroy();
        return wao.YES;
    },
    noClick: function(){
        this.destroy();
        return wao.NO;
    },
    cancelClick: function(){
        this.destroy();
        return wao.CANCEL;
    },
    doneClick: function(){
        this.destroy();
        return wao.DONE;
    },
    exitClick: function(){
        this.destroy();
        return wao.EXIT;
    },
    confirm: true,
    initWidget: function(){
        this._insThings(this);
        this.Super("initWidget", arguments);
    },
    _insThings: function (genitore){
        if (this.buttons!==null){
            this._toolBar = isc.Toolbar.create({
                buttonConstructor:"IButton",
                buttonDefaults:{
                    autoFit: false, 
                    height: 22,
                    overflow:'visible',
                    width:30,
                    labelLengthPad:8,
                    animateMembers:false,
                    titleStyle:'styleBottoni'
                },
                layoutRightMargin:4,
                layoutBottomMargin:4,
                align:"right",
                height:25,
                width: "100%",
                membersMargin: 6
	        });
            this._toolBar.addButtons(this.buttons);
            this.addItem(isc.SpacerItem.create({height:6}));
	        this.addItem(this._toolBar);
	    }
    }
});
