/** *  Modulo per la gestione dati in arrivo dal response di SmartClient
*/
function _ttl(cosa){
    try{
        console.log(cosa);
    }catch(errore){
//        isc.say(cosa);
    }
}
//isc.RPCManager.doClearPrompt=function(){
    //isc.clearPrompt();
    //return this.Super('doClearPrompt', arguments);
//};
function mostraFinestraMessaggi(data) {
    if (typeof(messaggiList) == 'undefined') {
        isc.ListGrid.create({
            ID: "messaggiList",
            alternateRecordStyles: true,
            fields: [
                {name:"tipo", title:" ", width:40, type:"image", imageURLPrefix:"/img/", imageURLSuffix:".png"},
                {name:"msg", title:"messaggio" }
            ],
            showAllRecords: true,
            fixedRecordHeights: false,
            canDragRecordsOut: false,
            canReorderRecords: false,
            canSort: true,
            canAcceptDroppedRecords: false,
            hoverWidth: 200,
            hoverHeight: 20,
            selectionType: "single",
            width: "100%",
            height: "100%",
            wrapCells: true,
            fixedRowHeights: false,
            autoSize: true,
            showHeader:false,
            emptyMessage: "<h3>Nessun messaggio</h3>",
            recordClick:function(viewer, record, recordNum, field, fieldNum, value, rawValue){
                try{
                    if(record.coords){
                        cuboPresenza.setEditaCella(record.coords.id,record.coords.c,record.coords.g);
                    }
                }catch(erre){}
            }
        });
    }
    if (typeof(wndMessasggi) == 'undefined') {
        isc.stdDialog.create({
            ID: "wndMessasggi",
            title: "Messaggi",
            align: "left",
            width: 600,
            height: 400,
            autoSize: false,
            items: [messaggiList],
            buttons: [isc.Dialog.CLOSE],
            headerIconDefaults:{
                height: 15,
                layoutAlign: "center",
                width: 15,
                src: "/img/icons/information.png"
            }
        });
    }
    wndMessasggi.show();
    messaggiList.setData(data);
    try{
        var coords = data[0].coords;
        cuboPresenza.setEditaCella(coords.id,coords.c,coords.g);
    }catch(erre){}
    messaggiList.focus();
}
function gestioneDatiResponse(data) {
    _lastResponse.hasConferma = false;
    _lastResponse.hasStato = false;
    _lastResponse.hasMessaggi = false;
    _lastResponse.hasErrors = false;
    _lastResponse._response = data;
    var msg = [];
    if (wao.isDef(data.data)){
        if (wao.isDef(data.data.response)) {
            _lastResponse.response = data.data.response;
            msg = _lastResponse.response.messaggi;
            _lastResponse.hasErrors = (msg.findAll('tipo', 'errore') !== null);
            _lastResponse.hasStato = (msg.findAll('tipo', 'stato') !== null);
            _lastResponse.hasMessaggi = (msg.findAll('tipo', 'messaggio') !== null);
            _lastResponse.hasConferma = (msg.findAll('tipo', 'conferma') !== null);
            _lastResponse.parsedData = _lastResponse.response.data || _lastResponse.response.results;
        }else{
            _lastResponse.parsedData = _lastResponse._response.data;
           }
    }else{
        _lastResponse.parsedData = null;
    }
    if (_lastResponse.parsedData){
        if (_lastResponse._response.context.tipo == 'xmll'){
            _lastResponse.parsedData = isc.XMLTools.toJS(isc.XMLTools.selectNodes(
                        _lastResponse.parsedData, _lastResponse._response.context.recordXPath || "*"));
        }else if(_lastResponse._response.context.tipo == 'xml'){
            _lastResponse.parsedData = isc.XMLTools.toComponents(_lastResponse.parsedData);
        }else if(_lastResponse._response.context.tipo == 'txt'){
            _lastResponse.parsedData = _lastResponse.parsedData;
        }else{
            try{
                _lastResponse.parsedData = Class.evaluate(_lastResponse.parsedData);
            }catch(errore_1){
                try{
                    _lastResponse.parsedData = Class.evaluate("data=" + _lastResponse.parsedData);
                }catch(errore_2){}
            }
        }
    }else{
        _lastResponse.parsedData = null;
    }
    if (_lastResponse.hasStato) {
        var stato = msg.findAll('tipo', 'stato');
        var last_stato = stato.length - 1;
        wao.showInfoMsg(stato[last_stato]);
    }
    if (_lastResponse.hasMessaggi || _lastResponse.hasErrors){
        var toshow = msg.map(function(item,index,array){
            if(item.tipo == 'errore' || item.tipo == 'messaggio') {return item;}
        });
        if (toshow.length) {mostraFinestraMessaggi(toshow);}
    }
    if (_lastResponse.hasConferma){
        if(_lastResponse.confermaCallback){
            var conferma = msg.findAll('tipo', 'conferma')[0];
            if (isA.Array(conferma.tasti)){
                var btn = { "YES":'s', "NO":'n', "CANCEL":'a',"CLOSE":'c' };
                _lastResponse.confermaCallback.type = '';
                for (var i = 0; i < conferma.tasti.length; i++){
                    _lastResponse.confermaCallback.type +=  btn[conferma.tasti[i]] || conferma.tasti[i];
                }
            }else{
                _lastResponse.confermaCallback.type = conferma.tasti;
            }
            wao.ask(conferma.msg,_lastResponse.confermaCallback);
        }
    }
    _lastResponse.stato = _lastResponse.hasErrors ? LRERROR : LRSUCCESS;
    if (_lastResponse.callback){
        //wao.__fCallback(_lastResponse.callback,_lastResponse.parsedData);
       _lastResponse.callback(_lastResponse.parsedData);
    }
    _lastResponse.done();
    //_lastResponse.stato = LRIDLE;
}
function _fURL(url,lista){
    var rurl = {};
    var nurl = url.split("?");
    nurl = nurl[nurl.length-1].split("&");
    for (var i = 0; i < nurl.length; i++){
        if (nurl[i].indexOf("=") != -1){
            var campo = nurl[i].split("=");
            if (lista){
                if (lista.contains(campo[0])) {rurl[campo[0]]=campo[1];}
            }else{
                rurl[campo[0]]=campo[1];
            }
        }
    }
    return rurl;
}
function _cUrl(nargs){
    var url = '';
    for (var proprieta in nargs) {
        if (isc.is.Array(nargs[proprieta])){
            for (var i = 0; i < nargs[proprieta].length;i++){
                url += "&" + proprieta + "=" + nargs[proprieta][i];
            }
        }else{
            url += "&" + proprieta + "=" + nargs[proprieta];
        }
    }
    return url;
}
function _gURL(args, gcodice, gperiodo) {
    var nargs = isc.clone(args);
    var url = "/get?";
    try {
        if (gcodice) {
            nargs.cod_ditta = nargs.cod_ditta || wao.getCodDitta();
        }
    } catch(errore_1) {}
    try {
        if (gperiodo) {
            nargs.periodo = nargs.periodo || ("01/" + wao.getPeriodo());
        }
    } catch(errore_2) {}
    return url + _cUrl(nargs);
}
function _gApp(app, method, args) {
    var nargs = isc.clone(args) || {};
    var url = "/app/" + app + "/" + method + "?";
    nargs.cod_ditta = nargs.cod_ditta || wao.getCodDitta();
    nargs.periodo = nargs.periodo || wao.getPeriodo();
    return url + _cUrl(nargs);
}
function _gAppUrl(url){
    return RegExp(/\/?(app\/\w+\/\w+)?/).exec(url)[1];
}
function newSendData(args){
    _lastResponse.init();
    _lastResponse.callback = args.callback || _lastResponse.callback;
    _lastResponse.confermaCallback = args.confermaCallback || _lastResponse.confermaCallback;
    var dati = args.dati || null;
    var params = isc.clone(args.params) || {};
    var get = args.get || '';
    var tipo = args.tipo || 'json';
    var recordXPath = args.recordXPath || null;
    var sUrl = args.url || 'get';
    var showPrompt = args.showPrompt || true;
    var promptStyle = args.promptStyle || "dialog";
    var dprompt = args.prompt || RPCManager.defaultPrompt;
    var queque = args.queque || false ;
    var download = args.download || false;
    var blocking = args.blocking || false;
    if (download){
        showPrompt = false;
        promptStyle = "cursor";
    }
    if (args.mparams){
        for (var prop in args.mparams){
            if (args.mparams.hasOwnProperty(prop)){
                params[prop]=args.mparams[prop];
            }
        }
    }
    if (isc.isA.Object(get)){
        get=_gURL(get).substr(6);
    }
    if (!('periodo' in _fURL(get))){
        params.periodo = params.periodo || wao.getPeriodo();
    }
    if (!('cod_ditta' in _fURL(get))){
        params.cod_ditta = params.cod_ditta || wao.getCodDitta();
    }
    params.__tipo_response = tipo;
    if (args.toXML && dati){
        params.dati = isc.Comm.xmlSerialize("dati",dati);
    } else if (args.toJSON && dati){
        params.dati = JSONEncoder.create().encode(dati);
    } else if(dati){
        params.dati = dati;
    }
    isc.RPCManager.startQueue(queque);
    _lastResponse.stato = LRLOAD;
    sUrl = (sUrl[0] == '/' ? '' : '/') + sUrl;
    isc.RPCManager.sendRequest({
        evalResult: true,
        downloadResult: download,
        promptStyle: promptStyle,
        showPrompt: showPrompt,
        params: params,
        prompt: dprompt,
        httpMethod: "POST",
        callback: gestioneDatiResponse,
        recordXPath: recordXPath,
        tipo: tipo,
        blocking: blocking,
        actionURL: sUrl + "?" + get
    });
    if (queque){
        isc.RPCManager.sendQueue();
    }
}
// gestione messaggi {{{
function _mostraMessaggio(messaggio, tipo) {
    var msg = [{
        tipo: tipo,
        msg: messaggio
    }];
    try {
        if (wndMessasggi.isVisible()) {
            msg = messaggiList.data.concat(msg);
        }
    } catch(errore) {}
    mostraFinestraMessaggi(msg);
}
function mostraErrore(errore) {
    _mostraMessaggio(errore, "errore");
}
function mostraInfo(info) {
    _mostraMessaggio(info, "messaggio");
}
// }}}
function _verificaSalvaCalendario(callback, argomenti){
    newSendData({
        url: 'app/presenze/verifica_salvataggio',
        confermaCallback:{
            action:{
                func: function(){
                    salvaCalendario();
                },
                obj:this
            },
            done:{
                func: function(){
                    _lastGriglia.discardAllEdits();
                    annullaModificheCalendario();
                    wao.__fCallback({func:callback,args:argomenti});
                },
                obj:this
            },
            cancel:{
                func:function(){
                    _lastGriglia.discardAllEdits();
                },
                obj:this
            }
        },
        callback:function(data){
            if (data){
                wao.__fCallback({func:callback, args:argomenti});
            }
        }
    });
    return false;
}
function _verificaSalvaAnagrafiche(callback, argomenti){
    var id_dipendente =  listDipendenti.last_dipe;
    var ochanges = false;
    if (listOrario){
        ochanges = listOrario.hasChanges() || frmOrario.valuesHaveChanged();
    }
    //if(listCampi.hasChanges() || ochanges || wao.isDefNotNull(listCampi.nuovo_codice)){
    if(listCampi.hasChanges() || ochanges){
        wao.ask('Salvare le modifiche ?',{
            type:"sna",
            doDone: false,
            action:function(){
                if(listCampi.hasChanges()){salvaCampi(listDipendenti.last_dipe);}
                if (listOrario){
                    if(listOrario.hasChanges() || frmOrario.valuesHaveChanged()){salvaOrario(listDipendenti.last_dipe);}
                }
                var ochanges = false;
                try{
                    ochanges = listOrario.hasChanges() || frmOrario.valuesHaveChanged();
                }catch(err){}
                if (listCampi.hasChanges() || ochanges){
                    Page.waitFor(_lastResponse, 'done',function(){
                        if (!_lastResponse.hasErrors){
                            _lastGriglia.discardAllEdits();
                            delete listCampi.nuovo_codice;
                            wao.__fCallback(callback,argomenti);
                        }
                    });
                }else{
                    _lastGriglia.discardAllEdits();
                    delete listCampi.nuovo_codice;
                    wao.__fCallback(callback,argomenti);
                }
            },
            done:{
                func: function(){
                    _lastGriglia.discardAllEdits();
                    delete listCampi.nuovo_codice;
                    wao.__fCallback(callback,argomenti);
                },
                obj:this
            },
            cancel:{
                func:function(){
                    _lastGriglia.discardAllEdits();
                },
                obj:this
            }
        });
       return false;
    }
    return true;
}
function _verificaSalvaStatus(callback, argomenti){
    if (_lastGriglia.hasChanges()){
        wao.ask('Salvare le modifiche ?',{
            type:'sna',
            action: "lstPeriodi.salvaPeriodi();",
            done:{func:function(){
                    wao.__fCallback(callback, argomenti);
                },
                obj:this
            },
            cancel:{func:function(){
                    _lastGriglia.discardAllEdits();
                },
                obj:this
            }
        });
        return false;
    }else{
        return true;
    }
}
