Dialog.OK_BUTTON_TITLE = 'Ok';
Dialog.APPLY_BUTTON_TITLE = 'Applica';
Dialog.YES_BUTTON_TITLE = 'Si';
Dialog.NO_BUTTON_TITLE = 'No';
Dialog.CANCEL_BUTTON_TITLE = 'Annulla';
Dialog.DONE_BUTTON_TITLE = 'Fatto';
Dialog.CONFIRM_BUTTON_TITLE = "Conferma";
Dialog.CONFIRM_TITLE = 'Conferma';
Dialog.CONFIRM = {
    getTitle: function() {
        return Dialog.CONFIRM_BUTTON_TITLE;
    },
    width: 75,
    click: function() {
        this.topElement.confirmClick();
    }
};
Dialog.CLOSE_BUTTON_TITLE = 'Chiudi';
Dialog.CLOSE_TITLE = 'Chiudi';
Dialog.CLOSE = {
    getTitle: function() {
        return Dialog.CLOSE_BUTTON_TITLE;
    },
    width: 75,
    click: function() {
        this.topElement.closeClick();
    }
};
Dialog.EXIT_BUTTON_TITLE = 'Esci';
Dialog.EXIT_TITLE = 'Esci';
Dialog.EXIT = {
    getTitle: function() {
        return Dialog.EXIT_BUTTON_TITLE;
    },
    width: 75,
    click: function() {
        this.topElement.exitClick();
    }
};
Dialog.SAY_TITLE = 'Info';
Dialog.WARN_TITLE = 'Nota';
Dialog.ASK_TITLE = 'Richiesta';
Dialog.ASK_FOR_VALUE_TITLE = 'Prego inserire un valore';
Dialog.LOGIN_TITLE = "Autentificazione Utente";
Dialog.USERNAME_TITLE = "Utente";
Dialog.PASSWORD_TITLE = "Password";
Dialog.LOGIN_BUTTON_TITLE = "Accedi";
Dialog.LOGIN_ERROR_MESSAGE = "Nome utente o password errati";
RPCManager.defaultPrompt = 'Connessione al server in corso...';
RPCManager.timeoutErrorMessage = "Errore di TimeOut durante l'operazione";
RPCManager.removeDataPrompt = "Eliminazione Record(s) in corso...";
RPCManager.saveDataPrompt = "Salvataggio dati in corso...";
RPCManager.fetchDataPrompt = "Recupero dei dati richiesti in corso...";
Operators.equalsTitle = "uguale";
Operators.notEqualTitle = "diverso";
Operators.greaterThanTitle = "maggiore di";
Operators.lessThanTitle = "minore di";
Operators.greaterOrEqualTitle = "maggiore o uguale a";
Operators.lessOrEqualTitle = "minore o uguale a";
Operators.betweenTitle = "compreso tra (esclusi)";
Operators.betweenInclusiveTitle = "compreso tra (inclusi)";
Operators.iContainsTitle = "contiene";
Operators.iStartsWithTitle = "comincia con";
Operators.iEndsWithTitle = "finisce con";
Operators.containsTitle = "contiene (maiuscolo/minuscolo)";
Operators.startsWithTitle = "comincia con (maiuscolo/minuscolo)";
Operators.endsWithTitle = "finisce con (maiuscolo/minuscolo)";
Operators.iNotContainsTitle = "non contiene";
Operators.iNotStartsWithTitle = "non comincia con";
Operators.iNotEndsWithTitle = "non finisce con";
Operators.notContainsTitle = "non contiene";
Operators.notStartsWithTitle = "non inizia con";
Operators.notEndsWithTitle = "non finisce con";
Operators.isNullTitle = " nullo";
Operators.notNullTitle = "non  nullo";
Operators.regexpTitle = "espressione riscontrata (maiuscolo/minuscolo)";
Operators.iregexpTitle = "espressione riscontrata";
Operators.inSetTitle = " uno di";
Operators.notInSetTitle = "non  uno di";
Operators.equalsFieldTitle = " uguale agli altri campi";
Operators.notEqualFieldTitle = " differente dalgi altri campi";
Operators.andTitle = "tutti";
Operators.notTitle = "nessuno";
Operators.orTitle = "alcuni";
GroupingMessages.upcomingTodayTitle = "Oggi";
GroupingMessages.upcomingTomorrowTitle = "Domani";
GroupingMessages.upcomingThisWeekTitle = "Questa settimana";
GroupingMessages.upcomingNextWeekTitle = "Prossima settimana";
GroupingMessages.upcomingNextMonthTitle = "Prossimo mese";
GroupingMessages.upcomingBeforeTitle = "Prima";
GroupingMessages.upcomingLaterTitle = "Dopo";
GroupingMessages.byDayTitle = "Per giorno";
GroupingMessages.byWeekTitle = "Per settimana";
GroupingMessages.byMonthTitle = "Per mese";
GroupingMessages.byQuarterTitle = "Per quarto";
GroupingMessages.byYearTitle = "Per anno";
GroupingMessages.byDayOfMonthTitle = "Per giorno del mese";
GroupingMessages.byUpcomingTitle = "Per prossimi";
GroupingMessages.byHoursTitle = "Per ore";
GroupingMessages.byMinutesTitle = "Per minuti";
GroupingMessages.bySecondsTitle = "Per secondi";
GroupingMessages.byMilisecondsTitle = "Per millisecondi";
Validator.notABoolean = "deve essere vero o falso";
Validator.notAString = "deve essere una stringa";
Validator.notAnInteger = "deve essere un numero intero";
Validator.notADecimal = "deve essere un numero decimale valido";
Validator.notADate = "deve essere una data";
Validator.mustBeLessThan = "deve essere minore di ${max}";
Validator.mustBeGreaterThan = "deve essere maggiore di ${min}";
Validator.mustBeLaterThan = "deve esser dopo di ${min.toShortDate()}";
Validator.mustBeEarlierThan = "deve essere prima di ${max.toShortDate()}";
Validator.mustBeShorterThan = "deve essere pi corto di ${max}";
Validator.mustBeLongerThan = "deve essere pi lungo di ${min}";
Validator.mustBeExactLength = "deve essere lugo esattamente ${max}";
Validator.requiredField = "campo obbligatorio";
Validator.notOneOf = "opzione non valida";
Date.shortDayNames = ["Dom", "Lun", "Mar", "Mer", "Gio", "Ven", "Sab"];
Date.shortMonthNames = ["Gen","Feb","Mar","Apr","Mag","Giu","Lug","Ago","Set","Ott","Nov","Dic"];
//Time.AMIndicator 
//Time.PMIndicator
Window.title = "Esse Paghe";
FilterBuilder.removeButtonPrompt = "Elimina";
FilterBuilder.addButtonPrompt = "Aggiungi";
FilterBuilder.rangeSeparator = "e";
//FilterBuilder.subClauseButtonTitle
FilterBuilder.subClauseButtonPrompt = "Aggiungi sottoclausola";
Button.title = "Bottone";
DateChooser.todayButtonTitle = "Oggi";
DateChooser.cancelButtonTitle = "Annulla";
DynamicForm.errorsPreamble = "Sono stati risconstrati i seguenti errori.";
DynamicForm.unknownErrorMessage = "Valore non valido";
//SelectOtherItem.otherTitle = "Altro...";
//SelectOtherItem.selectOtherPrompt = "Altro valore per<br/>?";
DateItem.invalidDateStringMessage = "Data non valida";
DateItem.pickerIconPrompt = "Mostra selettore date";
ValuesManager.unknownErrorMessage = "Valore non valido";
//DataBoundComponent.addFormulaFieldText = "Aggiungi formula";
//DataBoundComponent.editFormulaFieldText = "Modifica formula";
//DataBoundComponent.addSummaryFieldText = "Aggiungi sommario";
//DataBoundComponent.editSummaryFieldText = "Modifica sommario";
Selection.selectionRangeNotLoadedMessage = "Impossibile selezionare cos tanti record in una volta.<br/><br/>Si prega di provare a lavorare su gruppi pi piccoli";
GridRenderer.emptyMessage = "nullo";
ListGrid.emptyMessage = "";
isc.ListGrid.emptyMessage = "";
isc.ListGrid.loadingDataMessage = "Caricamento daiti...";
//ListGrid.loadingMessage = "";
//ListGrid.removeFieldTitle = "[Remove record]";
isc.ListGrid.cancelEditingConfirmationMessage = "Eliminando questa modifica verranno perse tutte le modifiche non salvate per questo record, continuare?";
isc.ListGrid.confirmDiscardEditsMessage = "Questa azione scarter tutte le modifiche non salvate per questa lista";
isc.ListGrid.discardEditsSaveButtonTitle = "Salva";
isc.ListGrid.freezeOnRightText = "Blocca a destra";
isc.ListGrid.freezeOnLeftText = "Blocca a sinistra";
isc.ListGrid.sortFieldAscendingText = "Ordinamento Ascendente";
isc.ListGrid.sortFieldDescendingText = "Ordinamento Discendente";
isc.ListGrid.fieldVisibilitySubmenuTitle = "Colonne";
isc.ListGrid.freezeFieldText = "Blocca ${viewer.getSummaryTitle(field)}";
isc.ListGrid.unfreezeFieldText = "Sblocca ${viewer.getSummaryTitle(field)}";
isc.ListGrid.groupByText = "Raggruppa per ${title}";
isc.ListGrid.ungroupText = "Togli raggruppamento";
isc.ListGrid.autoFitFieldText = "Adatta larghezza del campo";
isc.ListGrid.autoFitAllText = "Adatta larghezza di tutti i campi";
isc.ListGrid.emptyMessage = "";
isc.A.emptyMessage= "";
isc.ListGrid.showHeaderContextMenu = false;
TreeGrid.parentAlreadyContainsChildMessage = "Questo oggetto contiene gi un sotto oggetto con questo nome";
TreeGrid.cantDragIntoSelfMessage = "Impossibile trascinare un oggetto su se stesso";
TreeGrid.cantDragIntoChildMessage = "Impossibile trascinare un oggetto in un suo sotto elemento";
MenuButton.title = "Mostra Menu";
FormulaBuilder.autoHideCheckBoxLabel = "Nascondi automaticamente i campi utilizzati in formula";
FormulaBuilder.helpTextIntro = "Per l'aritmetica di base usare i simboli (+-/%).<p>Sono disponibili anche se seghuenti funzioni:";
FormulaBuilder.instructionsTextStart = "I seguenti campi sono utilizzabili in questo";
FormulaBuilder.samplePrompt = "<nobr>Per record: ${title}</nobr><br><nobr>Output: ${output}</nobr>";
SummaryBuilder.autoHideCheckBoxLabel = "Nascondi automaticamente i campi utilizzati nel sommario";
SummaryBuilder.helpTextIntro = "Sono disponibili le seguenti funzioni:";


isc.A.displayFormat = "toEuropeanShortDate";
isc.A.useTextField = true;


//Calendar.invalidDateMessage = "'Da' deve venire prima di 'A'";
//Calendar.dayViewTitle = "Giorno";
//Calendar.weekViewTitle = "Settimana";
//Calendar.monthViewTitle = "Mese";
//Calendar.timelineViewTitle = "Periodo";
//Calendar.eventNameFieldTitle = "Nome evento";
//Calendar.saveButtonTitle = "Salva evento";
//Calendar.detailsButtonTitle = "Modifica dettagli";
//Calendar.cancelButtonTitle = "Annulla";
//Calendar.previousButtonHoverText = "Precedente";
//Calendar.nextButtonHoverText = "Successivo";
//Calendar.addEventButtonHoverText = "Aggiungi evento";
//Calendar.datePickerHoverText = "Scegli data";



//isc.A.sortFieldAscendingText="Ordinamento Ascendente";
//isc.A.sortFieldDescendingText="Ordinamento Discendente";
//isc.A.fieldVisibilitySubmenuTitle="Colonne";
//isc.A.freezeFieldText="Blocca ${viewer.getSummaryTitle(field)}";
//isc.A.unfreezeFieldText="Sblocca ${viewer.getSummaryTitle(field)}";
//isc.A.groupByText="Raggruppa per ${title}";
//isc.A.ungroupText="Rimuovi raggruppamento";
//isc.A.$31g="ordina";
/*
isc.A.chartConstructor="FusionChart";
isc.A.groupIdField="groupId";
isc.A.groupParentIdField="groupParentId";
isc.A.groupIconPadding=5;
isc.A.$31h={canDragSelect:true,canDragRecordsOut:true,canReorderRecords:true,canAcceptDroppedRecords:true};
isc.A.$45l={bodyBackgroundColor:"backgroundColor",bodyStyleName:"styleName",fixedRecordHeights:"fixedRowHeights",fixedFieldWidths:"fixedColumnWidths",alternateRecordStyles:"alternateRowStyles",alternateRecordFrequency:"alternateRowFrequency",showAllRecords:"showAllRows"};
isc.B.push(isc.A.initWidget=function(){if(this.canAddFormulaFields&&isc.FormulaBuilder==null){this.logInfo("Required modules for adding formula fields not present - setting "+"canAddFormulaFields to false.");this.canAddFormulaFields=false}*/
