function mostraLogin(){
    var btnAccedi = isc.clone(isc.Dialog.CONFIRM);
    btnAccedi.getTitle = function(){ return "Accedi";};
    isc.stdDialog.create({
        width:278,
        height:135,
        title: "Login",
        ID: 'wndLogin',
        showShadow: true,
        showCloseButton: false,
        showMaximizeButton: false,
        showMinimizeButton: false,
        canDragReposition: false,
        canDragResize: false,
        autoCenter: true,
        isModal: false,
        showModalMask: false,
        headerIcon: "/img/icons/key.png",
        icon: "/img/icons/key.png",
        headerIconDefaults:{
            height: 15,
            layoutAlign: "center",
            width: 15,
            src: "/img/icons/key.png"
        },
        items:[
            isc.DynamicForm.create({
                margin:5,
                action: "/app/utenti/login",
                method: 'post',
                wrapItemTitles :false,
                autoDraw:false,
                fields:[
                    {title:'Utente',name:'username', type:"text", required:true},
                    {title:"Password",name:'passwd', type:"password", required:true,
                        keyPress:function (item, form, keyName, characterValue){
                                     if (keyName.toLowerCase() == "enter"){
                                         wndLogin.confirm();
                                     }
                        }
                    }
                ]
            })
        ],
        buttons:[btnAccedi],
        confirm: function(){
            if(this.items[0].validate()){
                this.items[0].submitForm();
                //document.location = "/";
                return false;
            }
            return false;
        },
        exitClick: function(){
            document.location = "/logout";
            return false;
        }
    });
    wndLogin.setTop(120);
}
