/**
 * modulo per le anagrafiche
 */
function _refreshDati(id_dipendente){
   delete (dipeSource.defaultParams.id_dipte);
   newSendData({
        url: "app/anagrafiche/gestione_anagrafiche",
        params:{
            id_dipte:id_dipendente,
            tipo:"i",
                stato:"visualizza",
                archivio: dipeSource.defaultParams.archivio
            },
            tipo:'txt',
            callback: function(data){
                rightSideLayout.getSection("datiPane").setTitle("Anagrafica: " + data.info);
            }
        });
        campiSource.fetchData({id_dipte:id_dipendente},"listCampi.setData(data);");
        listCampi.last_dipe = id_dipendente;
        if (typeof(listOrario) != 'undefined'){
            if(listOrario) {
                orarioSource.fetchData({id_dipte:id_dipendente},
                    function(data){
                        data = data.data;
                        listOrario.setData(data[0].orario);
                        frmOrario.setData(data[0].totali);
                        listOrario.getValido();
                    }
                );
            }
        }
        if (wao.isDefNotNull(listCampi.nuovo_codice)){
            wao.disabilitaScorrimento(true);
        }else{
            wao.disabilitaScorrimento();
        }
    }
    function refreshDati(id_dipendente){
        wao.verificaSalvataggio(_refreshDati,id_dipendente);
    }
    function creaAnagrafiche(){
        _lastGriglia = null;
        if (dipeSource.defaultParams.stato != 'elimina') {
            dipeSource.defaultParams.stato='lista';
        }
        delete dipeSource.defaultParams.nuovo_codice;
        var arc = campiLista[dipeSource.defaultParams.archivio];
        getListaDipe('anagrafiche');
        if ((listDipendenti.tipo != dipeSource.tipo) ||
                (dipeSource.defaultParams.stato == 'elimina') ||
                (dipeSource.last_archivio != dipeSource.defaultParams.archivio)){
            dipeSource.nfetch(arc.fields);
        }else{
            findForm.findItems();
        }
        dipeSource.last_archivio = dipeSource.defaultParams.archivio;
        delete dipeSource.defaultParams.id_dipte;
        dipeSource.defaultParams.stato='lista';
        var bottoni = [
            {consel:true, title:"Visualizza",accessKey:'v', click: 'listDipendenti.recordDoubleClick();'},
            {nomod:true, consel:true, title:"Copia",click:"copiaDipendente();", disabled:!wao.isModAna()},
            {nomod:true, title:"Inserisci",click:"inserisciDipendente();", disabled:!wao.isModAna()},
        {nomod:true, consel:true, title:"Elimina",click:"eliminaDipendente();", disabled:!wao.isModAna()},
        {title:"Esci", click:"document.location='/'"}
    ];
    wao.addSezione(arc.titolo,listDipendenti);
    wao.getBottoni(bottoni);
    wao.mostraFiltri({periodo:false});
}
function getValoriCampi(classe,lista,record,rowNum){
    if (!wao.isModAna()){ return; }
    var nomeObj = 'source_' + classe.replace(".","_").split("&")[0];
    if (DataSource.get(nomeObj) === null){
        var tipo = 'xml';
        var rpath = '/elementi/elemento';
        if (nomeObj == 'source_getCentriCosto'){
            tipo = 'json';
            rpath = null;
        }
        isc.DataSource.create({
            ID:nomeObj,
            dataFormat: tipo,
            showPrompt:true,
            dataURL: '/app/gestione/' + classe,
            recordXPath: rpath
        });
    }
    isc.ListGrid.create({
        ID: "lstValoriCampi",
        dataSource: nomeObj,
        alternateRecordStyles:true,
        showHeaderContextMenu: false,
        showPrompt:true,
        //showAllRecords:true,
        wrapCells: false,
        fixedRecordHeights: false,
        canDragRecordsOut:false,
        canReorderRecords:false,
        canSort:true,
        canAcceptDroppedRecords:false,
        hoverWidth:200,
        hoverHeight:20,
        selectionType:"single",
        //autoFitData: "horizontal",
        riga: rowNum,
        lista: lista,
        nrecord: record,
        width: 595,
        height: 380,
        useAllDataSourceFields:true,
        emptyMessage: '',
        recordDoubleClick: function recordDoubleClick (viewer, record, recordNum, field, fieldNum, value, rawValue){
           this.topElement.confirmClick();
        },
        setData: function (newData){
            try{
                var record = null;
                if(isc.isA.Array(newData)){
                    record = newData[0];
                }else{
                    record = newData.data[0];
                }
                this.fields=[];
                for (var prop in record){
                    if(record.hasOwnProperty(prop)){
                        this.fields.push({name:prop,title:prop.title()});
                    }
                }
                this.setFields(this.fields);
            }catch(errore){}
            this.Super('setData',arguments);
        }
    });
    isc.stdDialog.create({
        ID: "wndValori",
        title: "Ricerca",
        width: 600,
        height: 400,
        autoSize: true,
        riga: rowNum,
        lista: lista,
        autoDraw:false,
        confirm: function(){
            var record = lstValoriCampi.getSelectedRecord();
            this.lista.setEditValue(this.riga,"valore",record.codice);
            this.lista.setEditValue(this.riga,"decodifica",record.descrizione);
            return true;
        },
        buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
        items: [
            isc.SearchForm.create({
                ID:"findValori",
                top:10,
                cellPadding:0,
                numCols:1,
                fields:[
                    {name:"elemento", title:'Filtro',
                    icons: [{
                        src: "/img/demoApp/icon_view.png",
                        click: "findValori.findItems();"
                    }]
                    }
                ],
                findItems : function (categoryName) {
                    var findValues = this.getValues();
                    findValues.cod_ditta = wao.getCodDitta();
                    lstValoriCampi.filterData(findValues);
                }
            }),
            lstValoriCampi
        ]
    });
    nomeObj = DataSource.get(nomeObj);
    nomeObj.fetchData({cod_ditta:wao.getCodDitta(),id_dipte:listDipendenti.last_dipe},"wndValori.show();lstValoriCampi.setData(data);");
    //wndValori.show();
}
function _salvaCampi(lista){
    var _data = [];
    for (var i = 0; i < lista.getTotalRows(); i++) {
        //var record =lista.getEditValues(i);
        var record =lista.getEditedRecord(i);
        if (record){
            if (record.valore){
                if (typeof(record.valore)=='object'){
                    record.valore = record.valore.toEuropeanShortDate();
                }
            }
            _data.push(record);
        }
    }
    return _data;
}
function salvaCampi(){
    var lista=listCampi;
    var data = _salvaCampi(lista);
    dipeSource.defaultParams.stato='salva';
    var mparams =  {};
    if (lista.last_dipe) {mparams.id_dipte = lista.last_dipe;}
    newSendData({
        url: "app/anagrafiche/gestione_anagrafiche",
        params:dipeSource.defaultParams,
        mparams: mparams,
        dati:data,
        toXML: true,
        callback:function(data){
            if (!_lastResponse.hasErrors){
                dipeSource.defaultParams.stato='visualizza';
                _refreshDati(listCampi.last_dipe);
            }
        }
    });
    if (_lastResponse.stato == LRSUCCESS){
        dipeSource.defaultParams.stato='lista';
        listCampi.saveAllEdits();
        dipeSource.tipo = "forzaFetch";
        return true;
    }else{
        return false;
    }
}
function creaGrigliaDettagliAna(id_dipendente){
    //dipeSource.defaultParams.id_dipendente = id_dipendente;
    var dataURL = _gApp("anagrafiche", "gestione_anagrafiche", dipeSource.defaultParams);
    isc.DataSource.create({
        ID:"campiSource",
        dataFormat:"xml",
        dataURL: dataURL,
        recordXPath:"/campi/campo",
	    showPrompt: false,
        autoDraw: false,
        autoFetchData: false,
        canEdit: wao.isModAna(),
        fields:[
            { name:'codice_campo', title:"Codice", width:60, primaryKey:"true" },
            { name:'annotazione', width:30, title:"I", align:"center", type:"image", imageURLPrefix:"/img/", imageURLSuffix:".png" },
            { name:'descrizione', title:"Nome Campo", showHover:true, hoverHTML:"return record.annotazione", canHover: true },
            { name:'valore',canEdit:wao.isModAna(), editorType:"WaoTextItem",
                keyPress: function (item, form, keyName, characterValue) {
                    if (keyName == 'f6' || keyName == 'f8'){
                        var record = listCampi.getSelectedRecord();
                        var rowNum = listCampi.getEditRow();
                        var colNum = "valore";
                        getValoriCampi(record.listafrom,listCampi,record,rowNum,colNum);
                        return false;
                    }
                },
                doubleClick: function(){
                        var record = listCampi.getSelectedRecord();
                        var rowNum = listCampi.getEditRow();
                        var colNum = "valore";
                        getValoriCampi(record.listafrom,listCampi,record,rowNum,colNum);
                }
            },
            { name:'listafrom', width:30, title:" ", align:"center", type:"image", imageURLPrefix:"/img/", imageURLSuffix:".png", disabled:!wao.isModAna()},
            { name: 'decodifica',title:' ' }
        ]
    });
    isc.ListGrid.create(
    {
	    ID: "listCampi",
        showHeaderContextMenu: false,
        dataSource: "campiSource",
	    alternateRecordStyles:true,
        canGroupBy: false,
	    showAllRecords:true,
	    wrapCells: true,
	    fixedRecordHeights: false,
	    canDragRecordsOut:false,
	    canReorderRecords:false,
	    canSort:false,
	    canAcceptDroppedRecords:false,
	    hoverWidth:200,
	    hoverHeight:20,
	    selectionType:"single",
	    autoDraw:false,
	    editByCell: true,
	    autoFetchData:false,
	    autoSaveEdits: false,
        saveLocally: true,
        enterKeyEditAction: 'nextCell',
		//saveEdits: function(){},
	    id_dipendente: id_dipendente,
        emptyMessage: "",
	    codice_azienda: wao.getCodDitta(),
        //clearEditValue: function (editValuesID, colNum) {
            //colName = this.getField(colNum).name;
            //_ttl(editValuesID + " " + colName);
        //},
        getCellValidators: function(record,field){
            var newVal = this.getField(field);
            if (newVal){
                if (newVal.validators){
                    if (newVal.validators.findAll('lengthRange')){
                        newVal.validators.findAll('lengthRange').setProperty('max', parseInt(record.caratteri,10));
                    }
                }
                return newVal.validators;
            }else{
                return null;
            }
            return _3 ? _3.validators: null;
        },
        getRecordByCodice: function(codice){
            for (var i = 0; i < this.getTotalRows(); i++){
                if (this.getRecord(i).codice_campo == codice){
                    return this.getRecord(i);
                }
            }
            return null;
        },

        validateRow : function(rowNum){
            var record = this.getEditedRecord(rowNum);
            if (record.valida){
                newSendData({
                    url: "app/anagrafiche/gestione_anagrafiche",
					showPrompt: true,
                    promptStyle: "cursor",
                    params:{
                        id_dipte: this.last_dipe,
                        tipo: 'campi_abilitati',
                        archivio: 'a',
                        stato: 'visualizza',
                        codice_campo: record.codice_campo,
                        valore: record.valore
                    },
                    callback: function(data){
                        if (wao.isDefNotNull(data.data)){
                            data = data.data;
                        }
                        for (var codice in data){
                            if (data.hasOwnProperty(codice)){
                                var record = listCampi.getRecordByCodice(codice);
                                if (record){
                                    record.enabled = (data[codice].toLowerCase() == 'true');
                                }
                            }
                        }
                        listCampi.redraw();
                    }
                });
            }
            return this.Super('validateRow', arguments);
        },
	    cellClick: function (record, rowNum, colNum){
	        var campo = this.getField(colNum);
	        switch(campo.name){
		        case "annotazione":
		            if (record.annotazione){
			            isc.say("->" + record.annotazione + "<-");
		            }
		            break;
		        case "listafrom":
		            if (record.listafrom){
                        getValoriCampi(record.listafrom,this,record,rowNum,colNum);
		            }
		            break;
                default:
                    break;
	            }
	    },
	    rowClick:  function (record, rowNum, colNum){},
	    formatCellValue: function (value, record, rowNum, colNum){
	        var campo = this.getField(colNum);
	        switch(campo.name){
		        case "annotazione":
		            if (value){
			           value= '<img src="/img/documentinfo.png" />';
		            }
		            break;
		        case "listafrom":
		            if (value){
			            value= '<img src="/img/search.png" />';
		            }
		            break;
		        case "valore":
		            try {
                        value = wao.formatThis(value, record.formato);
                        if (typeof(value)=="object"){
			                if (record.formato == "D8"){
				                value = sprintf("%02d/%02d/%04d",value.getDate(), (value.getMonth()+1),value.getFullYear());
			                } else if (record.formato == "D6"){
				                value = sprintf("%02d/%04d",(value.getMonth()+1),value.getFullYear());
			                }
			            }
			            if (value.toLowerCase() == "true") {value = true;}
			            if (value.toLowerCase() == "false") {value = false;}
			            if (record.listafrom){ value = value.toUpperCase();}

		            } catch(err){}

		            break;
                default:
                    break;
	        }
	        return value;
        },
	    formatEditorValue: function (value, record, rowNum, colNum){
	        try {
		        if (value){
		            if (record.listafrom){
			            return value.toUpperCase();
                    }else{
                        return value;
                    }
		        }
		        return "";
	        } catch(err){}
	        return value;
	    },
	    getEditorType: function (field, values) {
            field.length = 0;
            field.editorProperties={actRecord:values};
            wao.activeEditRecord = values;
            field.validators= null;
	        switch (values.formato){
		        case "D8" : tipo = 'WaoDateItem' ; break ;
		        case "D6" : tipo = 'WaoDateItem' ; break ;
		        case "CH" : tipo = 'CheckboxItem' ; break ;
		        default :
		        tipo = 'WaoTextItem';
                field.length = values.caratteri;
                field.validators=[
                    {type:"lengthRange",min:0,max:parseInt(values.caratteri,10)}
                ];
		        break ;
	        }
	        return tipo;
	    },
	    getCellCSSText: function (record, rowNum, colNum) {
            var style = "";
            if (record.required){
                style += "color:#1826B0;";
            }
            if (this.getField(colNum).name != "valore"){
                style += "border-right: 1px solid #000000;";
            }
            return style;
	    },
        setData: function(newData){
           var iDati;
            if( isA.Array(newData)){
                iDati = newData;
            }else{
                iDati = newData.data;
            }
            for (var i = 0; i < iDati.length; i++){
                if (wao.isDefNotNull(iDati[i].enabled)){
                    iDati[i].enabled = (iDati[i].enabled.toLowerCase() == 'true');
                }else{
                    iDati[i].enabled =  false;
                }
                if (wao.isDefNotNull(iDati[i].required)){
                    iDati[i].required = (iDati[i].required.toLowerCase() == 'true');
                }else{
                    iDati[i].required = false;
                }
                if (wao.isDefNotNull(iDati[i].valida)){
                    iDati[i].valida = (iDati[i].valida.toLowerCase() == 'true');
                }else{
                    iDati[i].valida = false;
                }
            }
            this.Super('setData',arguments);
            this.redraw();
        }
    });

}
function creaMascheraOrario(codice_azienda,id_dipendente){
    isc.DataSource.create({
        ID:"orarioSource",
        dataFormat:"xml",
        autoFetchData: false,
        dataURL: _gApp('anagrafiche', 'gestione_anagrafiche',
            {tipo:'o', archivio:'d', stato:'visualizza'}),
        recordXPath:"//orari",
        fields:[
            {name:'giorni',canEdit:false},
            {name:'ore_lav',title:'Ore lav.teo',cellAlign:'right'},
            {name:'ore_retr',title:'Ore retr.teo',cellAlign:'right'},
            {name:'fng',title:'F.N.G.',type:"boolean",defaultValue:false},
            {name:'cod_cau_1',title:'Ca'},
            {name:'ore_cau_1',title:'Ore',cellAlign:'right'},
            {name:'cod_cau_2',title:'Ca'},
            {name:'ore_cau_2',title:'Ore',cellAlign:'right'},
            {name:'enabled',type:'boolean',hidden:true,defaultValue:false},
            {name:'settimana',hidden:true,type:'integer'},
            /* per form */
            {name:'numero_settimane'},
            {name:'ore_sett_ft',title:"Ore sett. tempo pieno", type:"text", textAlign:"right"},
            {name:'tot_ore_lav',title:"Ore lavorate", type:"text", textAlign:"right"},
            {name:'tot_ore_retr',title:"Ore retribuite", type:"text", textAlign:'right'},
            {name:'tot_gg_lav',title:"Giorni lavorati", type:"text", textAlign:'right'},
            {name:'tot_gg_retr',title:"Giorni retribuiti", type:"text", textAlign:'right'}
        ]
    });
    isc.ListGrid.create({
        ID: "listOrario",
        dataSource: "orarioSource",
        showHeaderContextMenu: false,
        enterKeyEditAction: 'nextCell',
        cellHeight:25,
        alternateRecordStyles:false,
        emptyMessage: '',
        alternateRecordFrequency: 8,
        showAllRecords:true,
        wrapCells: true,
        fixedRecordHeights: false,
        canDragRecordsOut:false,
        canReorderRecords:false,
        canSort:false,
        canAcceptDroppedRecords:false,
        hoverWidth:200,
        hoverHeight:20,
        selectionType:"single",
        autoDraw:true,
        canEdit:wao.isModAna(),
        autoSaveEdits:false,
        showResizeBar: true,
        autoFetchData: false,
        editEvent: 'click',
        baseStyle: 'listOrario',
        canReorderFields: false,
        validateByCell:true,
        fields:[
            {name:'giorni',canEdit:false},
            {name:'ore_lav',id:'ore_lav',title:'Ore lav.teo',cellAlign:'right',
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:'ore_retr',title:'Ore retr.teo',cellAlign:'right',
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:'fng',title:'F.N.G.',type:"boolean",editorType:"checkbox"},
            {name:'cod_cau_1',title:'Ca',characterCasing:"upper"},
            {name:'ore_cau_1',title:'Ore',cellAlign:'right',
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:'cod_cau_2',title:'Ca',characterCasing:"upper"},
            {name:'ore_cau_2',title:'Ore',cellAlign:'right',
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            }
        ],
        setValido: function(settimana){
            if (!settimana) {settimana = 0;}
            settimana=parseInt(settimana,10);
            frmOrario.getField('numero_settimane').setValue(settimana);
            for (i = 0; i < this.getTotalRows() ;i++){
                var record = this.getRecord(i);
                 record.enabled = (record.settimana <= settimana);
            }
            this.redraw();
        },
        getValido: function(){
            for (var i = 4 ; i > 0; i-- ){
                var record = this.getRecord(i*8-7);
                if (record){
                    if (record.enabled && record.enabled!='false'){
                        this.setValido(record.settimana);
                        return;
                    }
                }
            }
            this.setValido(0);
        },
        getCellCSSText: function (record, rowNum, colNum) {
            var style = "border-right: 1px solid;";
            return style;
        }
        //setData: function(newData){
            //if (isA.Array(newData)){
                //newData.map()
            //}
        //}
    });
    isc.DynamicForm.create({
        ID:'frmOrario',
        dataSource: "orarioSource",
        padding:20,
        colWidth:[60,"*"],
        align:'left',
        autoFetchData: false,
        fields:[
            {type:'header',defaultValue:'Settimane'},
            {
                name:'numero_settimane',
                type:"radioGroup",
                showTitle:false,
                titleOrientation:'top',
                title:'Settimane',
                vertical:false,
                valueMap:{
                    "0":"Nessuna",
                    "1":"Una",
                    "2":"Due",
                    "3":"Tre",
                    "4":"Quattro"
                },
                defaultValue:"0",
                change:"listOrario.setValido(value);",
                disabled: !wao.isModAna()
            },
            {type:'header',defaultValue:'Part-Time'},
            {name:'ore_sett_ft',title:"Ore sett. tempo pieno", type:"text", textAlign:"right",disabled: !wao.isModAna()},
            {type:'header',defaultValue:'Totali'},
            {name:'tot_ore_lav',title:"Ore lavorate", type:"text", textAlign:"right",disabled: !wao.isModAna()},
            {name:'tot_ore_retr',title:"Ore retribuite", type:"text", textAlign:'right',disabled: !wao.isModAna()},
            {name:'tot_gg_lav',title:"Giorni lavorati", type:"text", textAlign:'right',disabled: !wao.isModAna()},
            {name:'tot_gg_retr',title:"Giorni retribuiti", type:"text", textAlign:'right',disabled: !wao.isModAna()}
        ]
    });
    isc.HLayout.create({
        ID: 'layOrario',
        members:[listOrario,frmOrario]
    });
}
function creaDettagliAnagrafica(id_dipendente){
    id_dipendente = id_dipendente || 0;
    creaGrigliaDettagliAna(wao.getCodDitta(), id_dipendente);
    _lastGriglia = listCampi;
    listDipendenti.last_dipe = id_dipendente;
    mtabs ={ "Dati anagrafici":"01" };
    tabs = [];
    for (var descrizione in mtabs){
        if(mtabs.hasOwnProperty(descrizione)){
            tabs.push({
                align:"left",
                title:descrizione,
                pane:listCampi,
                icon:"/img/demoApp/icon_edit.png",
                id_funzione : mtabs[descrizione]
            });
        }
    }
    if (dipeSource.defaultParams.archivio == 'd'){
        creaMascheraOrario(wao.getCodDitta,id_dipendente);
        tabs.push({align:"left",title:"Gestione orario", pane:layOrario, ID:"tabOrario", icon:"/img/sc_inserttimefield.png"});
    }
    isc.TabSet.create({
	    ID:"anaTabs",
	    tabBarPosition: "top",
	    tabs: tabs,
        tabSelected:function (tabNum, tabPane, ID, tab){
            try{
                wao.verificaSalvataggio(null,null);
            } catch(errore){}
        }
    });
    wao.addSezione("anagrafica",anaTabs);
    wao.getBottoni([
        {ID:'btnPrimo', title:"<<", width:40, click:function(){
                refreshDati(listDipendenti.rscroll.first().id);
            }
        },
        {ID:'btnPrec', title:"<", width:40, click:function(){
                refreshDati(listDipendenti.rscroll.prev().id);
            }
        },
        {ID:'btnPros', title:">", width:40, click:function(){
               refreshDati(listDipendenti.rscroll.next().id);
            }
        },
        {ID:'btnUltimo', title:">>", width:40, click:function(){
               refreshDati(listDipendenti.rscroll.last().id);
            }
        },
        {title:"Aggiorna",click:"salvaAnagrafica();", disabled:!wao.isModAna()},
        {title:"Esci",click:"wao.verificaSalvataggio(creaAnagrafiche);"}
    ]);
    wao.mostraFiltri(false);
    refreshDati(id_dipendente);
    listCampi.nuovo_codice = dipeSource.defaultParams.nuovo_codice;
    if (wao.isDefNotNull(listCampi.nuovo_codice) || dipeSource.defaultParams.stato == 'inserisci'){
        wao.disabilitaScorrimento(true);
    }else{
        wao.disabilitaScorrimento();
    }
    infoTop.setContenuto();
}
function salvaAnagrafica(){
    if (listCampi.hasChanges()){salvaCampi(listCampi);}
    var ochanges = false;
    try{
        ochanges = listOrario.hasChanges()  || frmOrario.valuesHaveChanged();
        if (ochanges) {salvaOrario();}
    }catch(errl){}
    if (listCampi.hasChanges() || ochanges){
        Page.waitFor(_lastResponse, 'done', function(){
            if (!_lastResponse.hasErrors){
                creaAnagrafiche();
            }
        });
    }else{
        creaAnagrafiche();
    }
}
function _inserisciDipendente(nuovo_codice){
    if (nuovo_codice === null && dipeSource.defaultParams.archivio !=='s'){
        isc.say("Operazione annullata");
    }else{
        dipeSource.defaultParams.nuovo_codice = nuovo_codice;
        dipeSource.defaultParams.stato='verifica';
        newSendData({
            url: '/app/anagrafiche/gestione_anagrafiche',
            params:dipeSource.defaultParams,
            callback: function(data){
                if (!_lastResponse.hasErrors){
                    dipeSource.defaultParams.stato='inserisci';
                    creaDettagliAnagrafica();
                }else{
                    dipeSource.defaultParams.stato = 'lista';
                }
            }
        });
    }
}
function inserisciDipendente(){
    if(dipeSource.defaultParams.archivio != 's'){
        wao.askForValue("Codice dipendente","_inserisciDipendente(value)",{
            width: 200,
            field:{length: 5, type: "integer"}
        });
    }else{
        _inserisciDipendente(null);
    }
}
function _eliminaDipendente(stato){
	if (!stato){
	    isc.say("Operazione annullata");
	}else{
        var record  = listDipendenti.getSelectedRecord();
        dipeSource.defaultParams.stato = 'elimina';
        newSendData({
            url: '/app/anagrafiche/gestione_anagrafiche',
            params:dipeSource.defaultParams,
            mparams:{id_dipte:record.id}
        });
		creaAnagrafiche();
	}
}
function eliminaDipendente(){
    var record  = listDipendenti.getSelectedRecord();
    if (!record){
	    isc.warn("Nessun dipendente selezionato");
    } else {
        isc.ask("Eliminare il dipendente " + record.codice + " - " + record.nominativo + " ?","_eliminaDipendente(value)");
    }
}
function _copiaDipendente(nuovo_codice){
	if (nuovo_codice === null && dipeSource.defaultParams.archivio != 's'){
	    isc.say("Operazione annullata");
	}else{
        var record  = listDipendenti.getSelectedRecord();
        dipeSource.defaultParams.stato = 'verifica';
        dipeSource.defaultParams.nuovo_codice = nuovo_codice;
        newSendData({
            params:dipeSource.defaultParams,
            callback: function(data){
                if (!_lastResponse.hasErrors){
                    dipeSource.defaultParams.stato='duplica';
                    creaDettagliAnagrafica(record.id);
                }else{
                    dipeSource.defaultParams.stato = 'lista';
                }
            }
        });
	}
}
function copiaDipendente(){
    var record  = listDipendenti.getSelectedRecord();
    if (!record){
        isc.warn("Nessun dipendente selezionato");
    } else {
        if (dipeSource.defaultParams.archivio != 's'){
            wao.askForValue("Codice dipendente","_copiaDipendente(value)",{
                width:200,
                field:{length: 5, type: 'integer'}
            });
        }else{
            _copiaDipendente(null);
        }
    }
}
function salvaOrario(){
    var dati = [];
    for (var i = 0; i < listOrario.getTotalRows();i++){
        var dato = listOrario.getEditedRecord(i);
        if (!dato) {dato = listOrario.getRecord(i);}
        for (var d in dato){
            if(typeof dato[d] == 'string'){
                if (isc.isA.NumChar(dato[d])){
                    dato[d]=dato[d].replace(",",".");
                }
            }
        }
        if(!wao.isDefNotNull(dato.fng)){dato.fng=false;}
        delete (dato.enabled);
        delete (dato.customStyle);
        dati.push(dato);
    }
    var sattuale = 1;
    if (listOrario.getSelectedRecord()){
        sattuale = listOrario.getSelectedRecord().settimana;
    }
    var mparams=frmOrario.getValues();
    mparams.settiama_attuale = sattuale;
    mparams.tipo = 'o';
    mparams.stato = 'salva';
    if (listCampi.last_dipe) {mparams.id_dipte = listCampi.last_dipe;}
    newSendData({
        params:dipeSource.defaultParams,
        mparams: mparams,
        dati: dati,
        toXML: true
        //callback: function(){isc.say('salvato orari');}
    });
    listOrario.saveAllEdits();
}
function mostraAnaDipendenti(){
    dipeSource.defaultParams.archivio="d";
    creaAnagrafiche();
}
function mostraAnaCollaboratori(){
    dipeSource.defaultParams.archivio="c";
    creaAnagrafiche();
}
function mostraAnaDistaccati(){
    //alert("Funzionalit non attiva");
    //return;
    dipeSource.defaultParams.archivio="s";
    creaAnagrafiche();
}
